/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include "nSX2.h"
#include "PS2Edefs.h"

#include "DmaC.h"

void DMAC_SIF0_Transfer_Normal_Mode( void ) {
	_u32 	*DmaAdd;

	/* Check if Addr is inside the SPR Memory */
	if ( ((_u32)DmaC.Channel[ DMA_CH5 ]->memAdd > (_u32)0x81FFFFFF ) ||
	     ( ((_u32)DmaC.Channel[ DMA_CH5 ]->memAdd & (_u32)0xFFFF0000 ) == 0x80000000 )
		) {
		/*Find the Adress Pointer and pass it to the GS Pluggin*/
		DmaAdd = (  _u32 * )	&SPRMemory [ DmaC.Channel[ DMA_CH5 ]->memAdd & 0x3FFF];	

	}
	else {
		/*Find the Adress Pointer and pass it to the GS Pluggin*/
		DmaAdd = (  _u32 * )	&MipsMemory [ DmaC.Channel[ DMA_CH5 ]->memAdd & 0x01FFFFFF ];	
		
	}

#ifdef EMU_LOG
	EMU_LOG("[DMAC]SIF0 Transfer: Adress 0x%8.8lx Size:%ld", DmaC.Channel[ DMA_CH5 ]->memAdd, DmaC.Channel[ DMA_CH5 ]->size );
#endif
	
}



void DMAC_SIF0_Transfer ( void ) {

	char 	DmaTempText[256];

	/* if the control value is START */
	if ( ( DmaC.Channel[ DMA_CH5 ]->ctrl & 0x100 ) == 0x100 ) {
	
		/*Normal Transfert or Chained Transfer*/
		switch ( DmaC.Channel[ DMA_CH5 ]->ctrl & 0xFF ) {
		
			/* 	To Memory ( Not effective here ), Mode Chain, 
				No Adress pushed by call Tag , 
				No Transfers DMATAG 
				Enable IRQ bit of DMATAG
			*/
			case 0x84 : {
#ifdef DMAC_LOG
				DMAC_LOG("%8.8lx:[DMAC][SIF0][CHAIN][NO_TAG] Add:0x%8.8lx ", (long)MipsCpu.PC,
						(long)DmaC.Channel[ DMA_CH5 ]->tag  );
#endif
				DMAC_Transfer_SourceChain_Mode( DMA_CH5 , DISABLE_TRANSFERT_TAG ,ENABLE_TAG_IRQ, DMAC_SIF0_Transfer_Normal_Mode );
			
			break;
			}

			
			/*Other Transfer Mode Not Implemented*/
			default: 
#ifdef EMU_LOG
				EMU_LOG("%8.8lx:[DMAC][SIF0][MODE_?] mode:%2.2llx ", (long)MipsCpu.PC,(DmaC.Channel[ DMA_CH5 ]->ctrl & 0xFF ) );
#endif
		}
	
		if ( debug_dma == 1 ) PrintToDmaOutput (  " \n" );


		/*This call write the end of the dma transfert
		with writing 0 to the bit start of the DM2 channel Control */
		DmaC.Channel[ DMA_CH5 ]->ctrl = DmaC.Channel[ DMA_CH5 ]->ctrl &  0xFFFFFEFF ;
		DmaC.Channel[ DMA_CH5 ]->size = (_u32)0;	
	}
				
}

