/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/


#define	GS_LOG	GS_Log
//#undef	GS_LOG



/********************************************************************************************
							GS MAIN DECLARATIONS
*********************************************************************************************/
#define GS_PMODE 		0x12000000    		//Various PCRTC modes
#define GS_SMODE1 		0x12000010			//Related to Sync
#define GS_SMODE2 		0x12000020			//Related to Sync
#define GS_SRFSH 		0x12000030			//DRAM refresh
#define GS_SYNCH1 		0x12000040			//Related to Sync
#define GS_SYNCH2 		0x12000050			//Related to Sync
#define GS_SYNCV		0x12000060			//Related to Sync/start
#define GS_DISPFB1	 	0x12000070 			//Related to display buffer of Rectangular Area 1
#define GS_DISPLAY1 	0x12000080			//Rectangular Area 1 display position etc.
#define GS_DISPFB2 		0x12000090			//Related to display buffer of Rectangular Area 2
#define GS_DISPLAY2 	0x120000a0			//Rectangular Area 2 display position etc.
#define GS_EXTBUF 		0x120000b0			//Rectangular Area write buffer
#define GS_EXTDATA	 	0x120000c0			//Rectangular Area write data
#define GS_EXTWRITE 	0x120000d0			//Rectangular Area write start
#define GS_BGCOLOR 		0x120000e0			//Background color
#define GS_IMR			0x12001010			//IMR

typedef struct _GSRegisters {
	_u64	pmode;			// 0x00  -  Various PCRTC modes
	_u64	null0;			// 0x08 0x0C
	_u64	smode1;			// 0x10  -  Related to Sync
	_u64	null1;			// 0x18 0x1C
	_u64	smode2;			// 0x20  -  Related to Sync
	_u64	null2;			// 0x28 0x2C
	_u64	srfsh;			// 0x30  - DRAM refresh
	_u64	null3;			// 0x38 0x3C
	_u64	synch1;			// 0x40  -  Related to Sync
	_u64	null4;			// 0x48 0x4C
	_u64	synch2;			// 0x50  -  Related to Sync
	_u64	null5;			// 0x08 0x0C
	_u64	synchv;			// 0x60  -  Related to Sync/start
	_u64	null6;			// 0x68 0x6C
	_u64	dispfb1;		// 0x70  -  Related to display buffer of Rectangular Area 1
	_u64	null7;			// 0x78 0x7C
	_u64	display1;		// 0x80  -  Rectangular Area 1 display position etc.
	_u64	null8;			// 0x88 0x8C
	_u64	dispfb2;		// 0x90  -  Related to display buffer of Rectangular Area 2
	_u64	null9;			// 0x98 0x9C
	_u64	display2;		// 0xa0  -  Rectangular Area 2 display position etc.
	_u64	null10;			// 0xa8 0xaC
	_u64	extbuf;			// 0xb0  -  ectangular Area write buffer
	_u64	null11;			// 0xb8 0xbC
	_u64	extdata;		// 0xc0  -  Rectangular Area write data
	_u64	null12;			// 0xc8 0xcC
	_u64	extwrite;		// 0xd0  -  Rectangular Area write start
	_u64	null13;			// 0xd8 0xdC
	_u64	bgcolor;		// 0xe0  -  Background color


	_u64	null14;			// 0x48 0x4C  0xf0 0xf4 0xf8 0xfC
	_u64	r0;				// 0x00  -  
	

} GSRegisters;



















void 	GSUpdate			(void);

