#include <stdlib.h>
#include <stdio.h>


#include "nSX2.h"
#include "PS2Edefs.h"


#include "IntrC.h"
#include "bios_syscalls.h"

/*

*/
__inline _u32 INTC_ExecSubFunc( _u32 fAdress ,_u32 fOptions , _u32 fA0 , _u32 fA1, _u32 fA2) {
	_u64 	SavedRA, SavedPC;
	_u128 	GPR_temp[34];	//BackUp of GeneralRegisters
	_u32	ReturnValue;

	_u8		SavedInterrupt;	

	// Save the Program Counter and the Return Adress
	SavedPC = MipsCpu.PC;
	SavedRA = MipsCpu.GPR[CPU_REG_RA].lo;

    // Save all the General Registers 
	if (( fOptions & INTC_SUBF_SAVE_REG ) == INTC_SUBF_SAVE_REG )
		memcpy(&GPR_temp, &(MipsCpu.GPR), (sizeof(struct __u128))*34);

	// Set Sub Function Param
	if (( fOptions & INTC_SUBF_SET_A0 ) == INTC_SUBF_SET_A0 ) MipsCpu.GPR[CPU_REG_A0].lo = fA0;
	if (( fOptions & INTC_SUBF_SET_A1 ) == INTC_SUBF_SET_A1 ) MipsCpu.GPR[CPU_REG_A1].lo = fA1;
	if (( fOptions & INTC_SUBF_SET_A2 ) == INTC_SUBF_SET_A2 ) MipsCpu.GPR[CPU_REG_A2].lo = fA2;


	// ??
	SavedInterrupt = IntC.IntrEnable ;
	if ( IntC.ExecutingHandler == EXECUTING_HANDLER ) 
		IntC.IntrEnable = FALSE;


	
	// Change the PC and RA 
	MipsCpu.PC = fAdress;
	MipsCpu.GPR[CPU_REG_RA].lo = 0x80001000;	//This values is inside KSEG0 ( Kernel Segment 0 )

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%[BIOS]ExecSubFunc at 0x%8.8lx",(long)MipsCpu.PC );
#endif	

	//Execute the Handler 
 	while ((_u32)MipsCpu.PC != (_u32)0x80001000) {


		if ( MipsCpu.halt != 1 ) {
			// Crash nfl_blitz.iso
			//TIMERS_Update();		// Update Timer and Main Clock 
		} else {

			KeyEvent( (*PAD1keyEvent)() );
		}

		
		switch( MipsCpu.halt ) {

			// the CPU is running 
			case 0: MipsUpdateCpu(); break;

			// the CPU execute ONE opcode and Stop 
			case 2:
				MipsUpdateCpu();	//Execute the current opcode
				MipsCpu.halt = 1;	//And Stop
			break;
		
		}

		if ( MipsCpu.InterpRunning == FALSE ) {
			MipsCpu.PC 		= 0x80001000;
			MipsCpu.halt 	= 1;
		}
		
		// Prevents some errors on exec function 
		if ( (_u32)MipsCpu.PC == 0x0 ) MipsCpu.PC = 0x80001000;


		/* Need Comments ? */
		ComputeInstructionsPerSec();

	}

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%[BIOS]ExecSubFunc End",(long)MipsCpu.PC );
#endif	


	ReturnValue = (_u32)MipsCpu.GPR[CPU_REG_V0].lo;

	//Restore the General Register
	if (( fOptions & INTC_SUBF_SAVE_REG ) == INTC_SUBF_SAVE_REG ) 
		memcpy(&(MipsCpu.GPR), &GPR_temp, (sizeof(struct __u128))*34);

	// Restore Initial PC and RA values 
 	MipsCpu.GPR[CPU_REG_RA].lo 	= (_u32)SavedRA;
	MipsCpu.PC 					= (_u32)SavedPC;

	IntC.IntrEnable = SavedInterrupt;


	return ReturnValue;

}












