/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include "nSX2.h"
#include "PS2Edefs.h"


#include "IntrC.h"


char	* debug_INT0_Cause[]= {
"INTC_GS", 		"INTC_SBUS", "INTC_VBLANK_S", 	"INTC_VBLANK_E",
"INTC_VIF0", 	"INTC_VIF1", "INTC_VU0", 		"INTC_VU1",
"INTC_IPU", 	"INTC_TIM0", "INTC_TIM1" 
};


/********************************************************************************/
/*						INT 0	: from peripherals devices						*/
/********************************************************************************/
/*
Miss :
INTC_GS,	INTC_SBUS,
INTC_VIF0,	INTC_VIF1,
INTC_VU0,	INTC_VU1,
INTC_IPU
*/
void INTC_RaiseIntByCause ( _u8 fNumber ) {

	_u32	Mask;

	if ( IntC.IntrEnable == TRUE ) {

		Mask =  0x1 << fNumber ;

		if ( ( IntC.Reg->mask &  Mask ) == Mask ) {

			/* Direct Register Acces */
			IntC.Reg->stat = IntC.Reg->stat | Mask ;
			INTC_TriggerINT0( fNumber );
		}
	}
}

 


void INTC_TriggerINT0( _u8 IntrNumber ) {
	LinkedAddress * CurrentHandlerAdd;
	_u32	HandlerReturn;	
	_u32	HandlerCount = 0;

	_u128 		GPR_temp[34];	//BackUp of GeneralRegisters


	/* If an interrupt occurs on the  specified Cause ( Maybe this is not needed anymore, let's see... )*/
	if (IntC.Reg->stat & ( 1<< IntrNumber ) ) {

		/* If the Intc Handler is Active */
		if ( (IntC.IntByCause[ IntrNumber ].Status) == 1 ) {
			

		HandlerReturn = 0;		

		CurrentHandlerAdd = IntC.IntByCause[ IntrNumber ].HandlerAdd;

		IntC.ExecutingHandler	= EXECUTING_HANDLER;

		while ( (_u32)HandlerReturn != (_u32)0xFFFFFFFF ) {


			if ( CurrentHandlerAdd != NULL ) {

#ifdef INTC_LOG
		INTC_LOG("%8.8lx:[INTC][INT0]Cause : %d (%s) Handler n %d", (long)MipsCpu.PC,
			IntrNumber,debug_INT0_Cause[ IntrNumber ], HandlerCount );
#endif

HandlerReturn = INTC_ExecSubFunc( 	CurrentHandlerAdd->Add ,
									INTC_SUBF_SAVE_REG | INTC_SUBF_SET_A0 , 
									IntrNumber , 0, 0);				

				CurrentHandlerAdd = (LinkedAddress *)CurrentHandlerAdd->next;

			} else {

				HandlerReturn = (_u32)0xFFFFFFFF;
			}
	
			HandlerCount++;

		}

		/* Set to 0 the flag of the interrupt */	
		IntC.Reg->stat = IntC.Reg->stat & ~(1<<IntrNumber);

		if ( IntC.ExecutingHandler	== NEED_UPDATE_SCHEDULER ) {
			UpdatePS2Scheduler();	

		}
		IntC.ExecutingHandler = NO_EXECUTING_HANDLER;		 	
				
		} /* end of Intc Handler Active */
	} /* end of Interrupt occur */

		

}



