/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include "nSX2.h"
#include "PS2Edefs.h"


#include "IntrC.h"


char	* debug_INT1_Channel[]= {
"DMA_CH0_VIF0",		"DMA_CH1_VIF1",		"DMA_CH2_GIF",
"DMA_CH3_FROM_IPU",	"DMA_CH4_TO_IPU",	"DMA_CH5_SIF0",
"DMA_CH6_SIF1",		"DMA_CH7_SIF2",		"DMA_CH8_FROM_SPR",
"DMA_CH9_TO_SPR"
};



/********************************************************************************/
/*						INT 1	: from DMA Controller							*/
/********************************************************************************/
/*
Miss : 
CISn: Overflow with call stack
CISn: Underflow with call stack
BEIS, CISn: Bus error
SIS: DMA stall
MEIS: MFIFO empty
*/
void INTC_RaiseIntByDMA ( _u8 fNumber ) {

	_u32	Channel_CIM;

	if ( IntC.IntrEnable == TRUE) {
	
		Channel_CIM =  DmaC.Reg->stat & ( 0x10000 << fNumber ) ;

		if ( Channel_CIM == ( 0x10000 << fNumber ) ) {
			// INT 1 
			// Direct Register Acces 
			DmaC.Reg->stat = DmaC.Reg->stat | ( 0x1 << fNumber ) ;
			INTC_TriggerINT1( fNumber );
		}
	}

}
 



void INTC_TriggerINT1( _u8 Channel ) {

	_u128 		GPR_temp[34];	//BackUp of GeneralRegisters

	LinkedAddress * CurrentHandlerAdd;
	_u32	HandlerReturn;	
	_u32	HandlerCount = 0;

	/* If an interrupt occurs on the  specified Cause ( Maybe this is not needed anymore, let's see... )*/
	if (DmaC.Reg->stat & (1<<Channel)) {

		/* If the Intc Handler is Active */
		if ((IntC.IntByDMA[ Channel ].Status ) == 1) {
			
#ifdef INTC_LOG
			INTC_LOG("%8.8lx:[INTC][INT1]Channel : %d (%s) Handler n %d", (long)MipsCpu.PC,
				Channel,debug_INT1_Channel[Channel],HandlerCount);
#endif


		HandlerReturn = 0;		

		CurrentHandlerAdd = IntC.IntByDMA[ Channel ].HandlerAdd;

		while ( (_u32)HandlerReturn != (_u32)0xFFFFFFFF ) {

	

			if ( CurrentHandlerAdd != NULL ) {

#ifdef INTC_LOG
			INTC_LOG("%8.8lx:[INTC][INT1]Channel : %d (%s) Handler n %d", (long)MipsCpu.PC,
				Channel,debug_INT1_Channel[Channel],HandlerCount);
#endif

HandlerReturn = INTC_ExecSubFunc( 	CurrentHandlerAdd->Add ,
									INTC_SUBF_SAVE_REG | INTC_SUBF_SET_A0 , 
									Channel , 0, 0);				

				CurrentHandlerAdd = (LinkedAddress *)CurrentHandlerAdd->next;

			} else {

				HandlerReturn = (_u32)0xFFFFFFFF;
			}

			HandlerCount++;

		}

		/* Set to 0 the flag of the interrupt */	
		DmaC.Reg->stat = DmaC.Reg->stat & ~(1<<Channel);
				 	
				
		} /* end of Intc Handler Active */
	} /* end of Interrupt occur */

		

}












