/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/




//extern char RPCVER[4];// = "2000";


typedef struct _SifDmaData{
	_u32 data; 
	_u32 addr; 
	_u32 size; 
	_u32 mode;
} SifDmaData;

typedef struct _SifRpcData {
	_u32	paddr;	// packet address 
	_u32	pid;	// packet id 
	_s32	tid;	// thread id 
	_u32	mode;	// call mode 
} SifRpcData;

typedef struct _SifServeData {
	_u32    command;
	_u32	func;
	_u32    buff;
	_s32	size;	
	_u32	cfunc;
	_u32    cbuff;
	_s32	csize;	
	_u32 	client;
	_u32	paddr;
	_u32	fno;
	_u32	receive;
	_s32	rsize;
	_s32	rmode;
	_u32	rid;
	struct _SifServeData	*link;
	struct _SifServeData	*next;
	struct _SifServeData	*base;
} SifServeData;


typedef struct _SifClientData {
	struct _SifRpcData	rpcd;
	_u32	command;
	_u32	buff;
	_u32	cbuff;
	_u32	func;
	_u32	para_add;
	_u32	serve_add;				// _SifServeData		*serve;
} SifClientData;

/* command packet header (128bit) */
typedef  struct _SifCmdHdr{
	/*
 	unsigned int	psize:8;  packet size(min 16(hdr only),max 16*7)
	unsigned int	dsize:24; attended data size 
	*/
	_u32	size;		//
 	_u32	daddr;   	// Address of accompanying data
  	_u32	fcode;	 	// Number of command function that is called 
	_u32	opt;	 	// Data area that programmer can use 
} SifCmdHdr;


#define SIF_CMDI_SYSTEM 0x80000000 // system func call , not user func

#define SIF_CMDC_CHANGE_SADDR	( SIF_CMDI_SYSTEM | 0x00000000)	// system function (default) 
#define SIF_CMDC_SET_SREG		( SIF_CMDI_SYSTEM | 0x00000001)
#define SIF_CMDC_INIT_CMD		( SIF_CMDI_SYSTEM | 0x00000002)
#define SIF_CMDC_RESET_CMD		( SIF_CMDI_SYSTEM | 0x00000003)


typedef struct _SifRpcBind
{
   struct _SifCmdHdr		sifcmd;
   _u32						rec_id;		/* 04 */
   _u32						pkt_addr;	/* 05 */
   _u32						rpc_id;		/* 06 */
   _u32						client_addr;	/* 07 */
   _u32						rpc_number;	/* 08 */
}SifRpcBind;


typedef struct _SifRpcCall
{
   struct _SifCmdHdr		sifcmd;
   _u32						rec_id;		/* 04 */
   _u32						pkt_addr;	/* 05 */
   _u32						rpc_id;		/* 06 */
   _u32						client_addr;	/* 07 */
   _u32						rpc_number;	/* 08 */
   _s32				send_size;	/* 09 */
   _u32				receive_add;	/* 10 */
   _s32				rec_size;	/* 11 */
   _s32				has_async_ef;	/* 12 */
   _u32				server_add;		//struct t_rpc_server_data	*server;	/* 13 */  
   
   
}SifRpcCall;

