/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include "VU1_micromode.h"


static void (*COP2_MI_VU1_UPPER[64])(void) = {

VU1_ADDbc,	VU1_ADDbc,	VU1_ADDbc,	VU1_ADDbc, 	VU1_SUBbc,	VU1_SUBbc,	VU1_SUBbc,	VU1_SUBbc,
VU1_MADDbc,	VU1_MADDbc,	VU1_MADDbc,	VU1_MADDbc, VU1_MSUBbc,	VU1_MSUBbc,	VU1_MSUBbc,	VU1_MSUBbc,

VU1_MAXbc,	VU1_MAXbc,	VU1_MAXbc,	VU1_MAXbc, 	VU1_MINIbc,	VU1_MINIbc,	VU1_MINIbc,	VU1_MINIbc,
VU1_MULbc,	VU1_MULbc,	VU1_MULbc,	VU1_MULbc, 	VU1_MULq, 	VU1_MAXi, 	VU1_MULi, 	VU1_MINIi,

VU1_ADDq, 	VU1_MADDq, 	VU1_ADDi, 	VU1_MADDi, 	VU1_SUBq, 	VU1_MSUBq, 	VU1_SUBi, 	VU1_MSUBi,
VU1_ADD, 	VU1_MADD, 	VU1_MUL, 	VU1_MAX, 	VU1_SUB, 	VU1_MSUB, 	VU1_OPMSUB, VU1_MINI,

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI, 
VU1_COP2_MI_VU1_UPPER_T60, 						VU1_COP2_MI_VU1_UPPER_T61,	
VU1_COP2_MI_VU1_UPPER_T62,						VU1_COP2_MI_VU1_UPPER_T63


};




static void (*COP2_MI_VU1_UPPER_T60[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBAbc,	VU1_ITOF0,	VU1_FTOI0, 	VU1_MULAbc,	VU1_MULAq,
VU1_ADDAq, 	VU1_SUBAq, 	VU1_ADDA,		VU1_SUBBA, 		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};





static void (*COP2_MI_VU1_UPPER_T61[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBbc,	VU1_ITOF4,	VU1_FTOI4,	VU1_MULAbc,	VU1_ABS,
VU1_MADDAq,	VU1_MSUBAq,	VU1_MADDA,		VU1_MSUBA, 	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};



static void (*COP2_MI_VU1_UPPER_T62[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBAbc,	VU1_ITOF12,	VU1_FTOI12,	VU1_MULAbc,	VU1_MULAi,
VU1_ADDAi,	VU1_SUBAi,	VU1_MULA,		VU1_OPMULA,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};



static void (*COP2_MI_VU1_UPPER_T63[32])(void) = {
VU1_ADDAbc,	VU1_SUBAbc,	VU1_MADDAbc,	VU1_MSUBAbc,	VU1_ITOF15,	VU1_FTOI15,	VU1_MULAbc,	VU1_CLIP,
VU1_MADDAi,	VU1_MSUBAi,	VU1_NI,			VU1_NOP,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI
};


static void (*COP2_MI_VU1_LOWER[128])(void) = {

VU1_LQ,		VU1_SQ,		VU1_NI,		VU1_NI,		VU1_ILW,		VU1_ISW,		VU1_NI,			VU1_NI,		
VU1_IADDIU,	VU1_ISUBIU,	VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_FCEQ,	VU1_FCSET,	VU1_FCAND,	VU1_FCOR,	VU1_FSEQ,		VU1_FSSET,		VU1_FSAND,		VU1_FSOR,
VU1_FMEQ,	VU1_NI,		VU1_FMAND,	VU1_FMOR,	VU1_FCGET,		VU1_NI,			VU1_NI,			VU1_NI,
VU1_B,		VU1_BAL,	VU1_NI,		VU1_NI,		VU1_JR,			VU1_JALR,		VU1_NI,			VU1_NI,
VU1_IBEQ,	VU1_IBNE,	VU1_NI,		VU1_NI,		VU1_IBLTZ,		VU1_IBGTZ,		VU1_IBLEZ,		VU1_IBGEZ,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_COP2_MI_VU1_LOWER_T64,VU1_NI,VU1_NI,VU1_NI,	VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI

};



static void (*COP2_MI_VU1_LOWER_T64[64])(void) = {
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,			VU1_NI,			VU1_NI,			VU1_NI,
VU1_IADD,	VU1_ISUB,	VU1_IADDI,	VU1_NI,		VU1_IAND,		VU1_IOR,		VU1_NI,			VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_COP2_MI_VU1_LOWER_T64_60,	VU1_COP2_MI_VU1_LOWER_T64_61,	VU1_COP2_MI_VU1_LOWER_T64_62,	VU1_COP2_MI_VU1_LOWER_T64_63


};



static void (*COP2_MI_VU1_LOWER_T64_60[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_MOVE,	VU1_LQI,	VU1_DIV,	VU1_MTIR,
VU1_RNEXT,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_MFP,	VU1_XTOP,	VU1_XGKICK,	VU1_ESADD,	VU1_EATANxy,VU1_ESQRT,	VU1_ESIN


};





static void (*COP2_MI_VU1_LOWER_T64_61[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_MR32,	VU1_SQI,	VU1_SQRT,	VU1_MFIR,
VU1_RGET,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_XITOP,	VU1_NI,		VU1_ERSADD,	VU1_EATANxz,VU1_ERSQRT,	VU1_EATAN



};




static void (*COP2_MI_VU1_LOWER_T64_62[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_LQD,	VU1_RSQRT,	VU1_ILWR,
VU1_RINIT,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_ELENG,	VU1_ESUM,	VU1_ERCPR,	VU1_EEXP

};


static void (*COP2_MI_VU1_LOWER_T64_63[32])(void) = {

VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_SQD,	VU1_WAITQ,	VU1_ISWR,
VU1_RXOR,	VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,
VU1_NI,		VU1_NI,		VU1_NI,		VU1_NI,		VU1_ERLENG,	VU1_NI,		VU1_WAITP,	VU1_NI

};






