#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

#include "r5900_main.hpp"
#include "r5900_DBG.hpp"

#define	R5900_OP_LOG	R5900_OP_Log

// Ease the code
#define		_OPCODE_				MipsCpu_opcode
#define		_VU_OPCODE_				MipsCpu_vuOpcode

//This macro decode the memory and Fill the opcode field of the cpu
#define		CURRENT_RT				( ( (_u32)_OPCODE_ >> 16 )  & (_u32)0x0000001F )
#define		CURRENT_RS				( ( (_u32)_OPCODE_ >> 21 )  & (_u32)0x0000001F )
#define		CURRENT_RD				( ( (_u32)_OPCODE_ >> 11 )  & (_u32)0x0000001F )
#define		CURRENT_BASE			( ( (_u32)_OPCODE_ >> 21 )  & (_u32)0x0000001F )
#define		CURRENT_SA				( ( (_u32)_OPCODE_ >> 6  )  & (_u32)0x0000001F )
#define		CURRENT_IMM				(((_OPCODE_)& 0xFFFF))
#define		CURRENT_OFFSET			(((_OPCODE_)& 0xFFFF))
#define		CURRENT_INSTR_INDEX		(((_OPCODE_)& 0x3FFFFFF))
#define		CURRENT_SEL				(((_OPCODE_)& 0x7))

#define		CURRENT_FT				( ( (_u32)_OPCODE_ >> 16 )  & (_u32)0x0000001F )
#define		CURRENT_FD				( ( (_u32)_OPCODE_ >> 6  )  & (_u32)0x0000001F )
#define		CURRENT_FS				( ( (_u32)_OPCODE_ >> 11 )  & (_u32)0x0000001F )

#define		CURRENT_CC				(((_OPCODE_)& 0x700)>>8)
#define		CURRENT_CCB				(((_OPCODE_)& 0x1C0000)>>18)

#define		CURRENT_ID				( ( (_u32)_OPCODE_ >> 11 )  & (_u32)0x0000001F )

#define		CURRENT_VU_FT				(((_VU_OPCODE_)& 0x1F0000)>>16)
#define		CURRENT_VU_FD				(((_VU_OPCODE_)& 0x7C0)>>6)
#define		CURRENT_VU_FS				(((_VU_OPCODE_)& 0xF800)>>11)

#define		CURRENT_VU_FSF				(((_VU_OPCODE_) >> 21) & 0x3 )
#define		CURRENT_VU_FTF				(((_VU_OPCODE_) >> 23) & 0x3 )
#define		CURRENT_VU_BC				(((_VU_OPCODE_) & 0x3))
#define		CURRENT_VU_DEST				(((_VU_OPCODE_) >> 21) & 0xF)

#define		CURRENT_VU_IT				(((_VU_OPCODE_)& 0x1F0000)>>16)
#define		CURRENT_VU_IS				(((_VU_OPCODE_)& 0xF800)>>11)
#define		CURRENT_VU_ID				(((_VU_OPCODE_)& 0x7C0)>>6)			//TAKE CARE OF CURRENT_ID



char debugTempText[100];
char debugTempOpcodeText[100];

_u32    MipsCpu_opcode     ;
_u32    MipsCpu_vuOpcode   ;
_u32    MipsCpu_PC         ;

/* LOG Function for the Interrupt Controller*/
void R5900_OP_Log ( char * ftext  , ...   ) {

   	va_list ap;
	va_start (ap, ftext);
	vsprintf (debugTempText, ftext, ap);
	va_end (ap);
}


void    DBG_NI( ) {		R5900_OP_LOG("NI");}


/*****************************************************************************************************************
									COP0 INSTRUCTION SET
*****************************************************************************************************************/

void    DBG_COP0()	{	DBG_cop0_opc[(_OPCODE_ & 0x3E00000)>>21]();}

void	DBG_C0() 	{	DBG_cop0c0_opc[(_OPCODE_ & 0x3F)](); }

void 	DBG_BC0()	{	DBG_cop0c0_bc0_opc[((_OPCODE_ >> 21 ) & 0x3)]();}


void DBG_BC0F()		{	
	R5900_OP_LOG("bc0f  0x%8.8lx", 
		MipsCpu_PC+(((_s16) CURRENT_IMM << 2 ) + 4 ) );
}

void DBG_BC0T()		{
	R5900_OP_LOG("bc0t 0x%8.8lx", 
		MipsCpu_PC+(((_s16) CURRENT_IMM << 2 ) + 4 ) ); 
}

void DBG_BC0FL()	{
	R5900_OP_LOG(" bc0fl 0x%8.8lx",
		MipsCpu_PC+(((_s16) CURRENT_IMM << 2 ) + 4 ) ); 
}
void DBG_BC0TL()	{	
	R5900_OP_LOG(" bc0tl 0x%8.8lx", 
		MipsCpu_PC+(((_s16) CURRENT_IMM << 2 ) + 4 ) );
}


void    DBG_CACHE( ) {R5900_OP_LOG("CACHE");}

void   	DBG_MF0() 	{
	R5900_OP_LOG("mfc0 %s, %s", 
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_cop0_reg[CURRENT_RD] );
}

void   	DBG_MT0() 	{
	R5900_OP_LOG("mtc0 %s, %s",
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_cop0_reg[CURRENT_RD] );
}

void	DBG_TLBP() 	{	R5900_OP_LOG("tlbp" );}

void	DBG_TLBR() 	{ R5900_OP_LOG("tlbr" );}

void	DBG_TLBWI() {	R5900_OP_LOG("tlbwi");}

void	DBG_TLBWR() {	R5900_OP_LOG("tlbwr" );}

void	DBG_ERET() 	{	R5900_OP_LOG("eret"	);}

void 	DBG_EI() 	{ R5900_OP_LOG("ei"	); }

void 	DBG_DI() 	{	R5900_OP_LOG("di");}

/*****************************************************************************************************************
									COP1 INSTRUCTION SET
*****************************************************************************************************************/

void    DBG_COP1	()		{	DBG_cop1_opc[( _OPCODE_ & 0x3E00000)>>21 ](); }

void	DBG_BC1		()		{ 	DBG_cop1_bc1_opc[( _OPCODE_ >>16)& 0x3 ](); }

void	DBG_COP1_S	()		{ 	DBG_cop1_s_opc[ _OPCODE_ & 0x3F ](); };

void	DBG_COP1_W	()		{ 	DBG_cop1_W_L_opc[ _OPCODE_ & 0x3F ](); }


void	DBG_ABS_S	( void )	{	
	R5900_OP_LOG("abs.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD],DBG_debug_r5900_cop1_reg[CURRENT_FS] );
} 	

void	DBG_ADD_S	( void )	{	
	R5900_OP_LOG("add.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS] ,
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 

void 	DBG_ADDA_S	( void )	{	
	R5900_OP_LOG("adda.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 

void	DBG_BC1F	( void )	{	
	R5900_OP_LOG("bc1f %lx, 0x%4.4lx",  
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) );
} 

void	DBG_BC1FL	( void )	{	
	R5900_OP_LOG("bc1fl %lx, 0x%4.4lx",  
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) );
} 


void	DBG_BC1T	( void )	{	
	R5900_OP_LOG("bc1t %lx, 0x%4.4lx",  
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) );
} 

void	DBG_BC1TL	( void )	{	
	R5900_OP_LOG("bc1tl %lx, 0x%4.4lx",  
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) );
}

void	DBG_C_EQ_S	( void )	{	
	R5900_OP_LOG("c.eq.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], DBG_debug_r5900_cop1_reg[CURRENT_FT] );
}	

void	DBG_C_F_S	( void )	{	
	R5900_OP_LOG("c.f.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 	

void	DBG_C_OLE_S	( void )	{	
	R5900_OP_LOG("c.ole.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 

void	DBG_C_OLT_S	( void )	{	
	R5900_OP_LOG("c.olt.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], DBG_debug_r5900_cop1_reg[CURRENT_FT] );
}	

void	DBG_CFC1	( void )	{	
	R5900_OP_LOG("cfc1 %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
} 		

void	DBG_CTC1	( void )	{	
	R5900_OP_LOG("ctc1 %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
} 	

void	DBG_CVTS_W	( void )	{	
	R5900_OP_LOG("cvt.s.w %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
}

void	DBG_CVT_W_S	( void )	{	
	R5900_OP_LOG("cvt.w.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
}	

void	DBG_DIV_S	( void )	{	
	R5900_OP_LOG("div.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT]);
} 	

void    DBG_LWC1	( void )	{	
	R5900_OP_LOG("lwc1 %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_cop1_reg[CURRENT_FT], CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void 	DBG_MADD_S	( void )	{	
	R5900_OP_LOG("madd.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
}

void 	DBG_MADDA_S	( void )	{
	R5900_OP_LOG("madda.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 

void 	DBG_MAX_S	( void )	{	
	R5900_OP_LOG("max.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
}	

void	DBG_MFC1	( void )	{	
	R5900_OP_LOG("mfc1 %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
}

void	DBG_MIN_S	( void )	{	
	R5900_OP_LOG("min.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 

void	DBG_MOV_S	( void )	{	
	R5900_OP_LOG("mov.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
} 

void 	DBG_MSUB_S	( void )	{	
	R5900_OP_LOG("msub.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD],	DBG_debug_r5900_cop1_reg[CURRENT_FS],
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
}

void 	DBG_MSUBA_S	( void )	{	
	R5900_OP_LOG("msuba.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD],	DBG_debug_r5900_cop1_reg[CURRENT_FS],
		DBG_debug_r5900_cop1_reg[CURRENT_FT] );
} 

void	DBG_MTC1	( void )	{	
	R5900_OP_LOG("mtc1 %s, %s", 
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
}	

void	DBG_MUL_S	( void )	{	
	R5900_OP_LOG("mul.s %s, %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS],
		DBG_debug_r5900_cop1_reg[CURRENT_FT]);
} 

void	DBG_MULA_S	( void )	{	
	R5900_OP_LOG("mula.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], DBG_debug_r5900_cop1_reg[CURRENT_FT]);
} 
 
void	DBG_NEG_S	( void )	{	
	R5900_OP_LOG("neg.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS] );
}


void	DBG_RSQRT_S	( void )	{	
	R5900_OP_LOG("rsqrt.s %s, %s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FT], DBG_debug_r5900_cop1_reg[CURRENT_FD] );
}

void	DBG_SQRT_S	( void )	{	
	R5900_OP_LOG("sqrt.s %s,%s",  
		DBG_debug_r5900_cop1_reg[CURRENT_FT], DBG_debug_r5900_cop1_reg[CURRENT_FD] );
}		

void	DBG_SUB_S	( void )	{
	R5900_OP_LOG("sub.s %s, %s, %s\n",  
		DBG_debug_r5900_cop1_reg[CURRENT_FD], DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT]);
} 		

void 	DBG_SUBA_S	( void )	{	
	R5900_OP_LOG("sub.s %s, %s\n",  
		DBG_debug_r5900_cop1_reg[CURRENT_FS], 
		DBG_debug_r5900_cop1_reg[CURRENT_FT]);
} 

void    DBG_SWC1	( void )	{	
	R5900_OP_LOG("swc1 %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_cop1_reg[CURRENT_FT], CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

/*****************************************************************************************************************
									CPU INSTRUCTION SET
*****************************************************************************************************************/

void 	DBG_SPECIAL()	{	DBG_special_opc[(_OPCODE_  & 0x3F)]();	}

void 	DBG_REGIMM()	{	DBG_regimm_opc[(_OPCODE_  & 0x1F0000)>>16]();		}

void   DBG_ADD     () {
	R5900_OP_LOG("add %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}

void    DBG_ADDI   () {
	R5900_OP_LOG("addi %s, %s, 0x%4.4lx",
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void    DBG_ADDIU () {
	R5900_OP_LOG("addiu %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void   DBG_ADDU    () {
	R5900_OP_LOG("addu %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}

void   DBG_AND () {
	R5900_OP_LOG("and %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void    DBG_ANDI() {
	R5900_OP_LOG("andi %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void     DBG_BEQ () {
	R5900_OP_LOG("beq %s, %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS],DBG_debug_r5900_reg[CURRENT_RT], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
} 

void     DBG_BEQL() {
	R5900_OP_LOG("beql %s, %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS],DBG_debug_r5900_reg[CURRENT_RT], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BGEZ() {
	R5900_OP_LOG("bgez %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS],
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BGEZAL () {
	R5900_OP_LOG("bgez %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BGEZALL() {
	R5900_OP_LOG("bgez %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS],
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BGEZL  () {		
	R5900_OP_LOG("bgezl %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}


void     DBG_BGTZ () {
	R5900_OP_LOG("bgtz %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void    DBG_BGTZL() {		
	R5900_OP_LOG("bgtzl %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void     DBG_BLEZ () {
	R5900_OP_LOG("blez %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS] ,
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void    DBG_BLEZL() {		
	R5900_OP_LOG("blezl %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS] ,
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void	DBG_BLTZ() {
	R5900_OP_LOG("bltz %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS] ,
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BLTZAL () {
	R5900_OP_LOG("bltzal %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BLTZALL() {
	R5900_OP_LOG("bltzall %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS],
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void      DBG_BLTZL  () {		
	R5900_OP_LOG("bltzl %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS] ,
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void     DBG_BNE () {
	R5900_OP_LOG("bne %s, %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS],DBG_debug_r5900_reg[CURRENT_RT], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void     DBG_BNEL() {
	R5900_OP_LOG("bnel %s, %s, 0x%8.8lx",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT], 
		MipsCpu_PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 ) ); 
}

void	DBG_BREAK()	{R5900_OP_LOG("BREAK"); }	


void	DBG_DADD()	{	
	R5900_OP_LOG("dadd %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] ); 
}

void	DBG_DADDI()	{
	R5900_OP_LOG("daddi %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM ); 
}

void    DBG_DADDIU    () {
	R5900_OP_LOG("daddiu %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM ); 
}

void   DBG_DADDU  () {
	R5900_OP_LOG("daddu %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] ); 
}


void   DBG_DIV  () {		
	R5900_OP_LOG("div %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] ); 
}
 
void   DBG_DIVU () {
	R5900_OP_LOG("divu %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] ); 
}

void   DBG_DSLL     () {
	R5900_OP_LOG("daddiu %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA ); 
}

void   DBG_DSLL32  () {
	R5900_OP_LOG("daddiu %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA ); 
}

void   DBG_DSLLV () {	
	R5900_OP_LOG("dsllv %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] ); 
}

void   DBG_DSRA  () {
	R5900_OP_LOG("dsra %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA );
}

void   DBG_DSRA32() {
	R5900_OP_LOG("dsra32 %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT],CURRENT_SA );
}

void   DBG_DSRAV () {
	R5900_OP_LOG("dsrav %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg [CURRENT_RT],CURRENT_SA );
}

void   DBG_DSRL  () {
	R5900_OP_LOG("dsrl %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA ); 
}

void   DBG_DSRL32   () {
	R5900_OP_LOG("dsrl32 %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT],CURRENT_SA );

}

void   DBG_DSRLV () {	
	R5900_OP_LOG("srlv %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}

void   DBG_DSUB  () {	
	R5900_OP_LOG("dsub %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}

void   DBG_DSUBU() {
	R5900_OP_LOG("dsubu %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}


void DBG_J() {
	_u64 	target_branch;
	target_branch = (_u32)(CURRENT_INSTR_INDEX << 2 ) ;
	R5900_OP_LOG("j 0x%8.8lx",  target_branch );

}

void     DBG_JAL  () {
	_u64 	target_branch;
	target_branch = CURRENT_INSTR_INDEX  << 2;
	R5900_OP_LOG("jal 0x%8.8lx",  target_branch );
}

void   DBG_JALR () {
	_u64	branch_target;
	R5900_OP_LOG("jalr %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS] 		 );
}


void   DBG_JR   () {
	_u64	branch_target;
	R5900_OP_LOG("jr %s",
		DBG_debug_r5900_reg[CURRENT_RS]  );
}

void    DBG_LB     () {
	R5900_OP_LOG("lb %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void   DBG_LBU () {
	R5900_OP_LOG("lbu %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void    DBG_LD   () {

	R5900_OP_LOG("ld %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );

}

void DBG_LDL() {
	R5900_OP_LOG("ldl %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_LDR() {  
	R5900_OP_LOG("ldr %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void    DBG_LH    () {
	R5900_OP_LOG("lh %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT],(long)CURRENT_OFFSET,DBG_debug_r5900_reg[CURRENT_BASE] ); 
}


void    DBG_LHU () {
	R5900_OP_LOG("lhu %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT],(long)CURRENT_OFFSET,DBG_debug_r5900_reg[CURRENT_BASE] );
}


void    DBG_LUI  () {
	R5900_OP_LOG("lui %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], CURRENT_IMM );
}

void    DBG_LW   () {
	R5900_OP_LOG("lw %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_LWL() {
	R5900_OP_LOG("lwl %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_LWR() {
	R5900_OP_LOG("lwr %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void    DBG_LWU   () {
	R5900_OP_LOG("lwu %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT],(long)CURRENT_OFFSET,DBG_debug_r5900_reg[CURRENT_BASE] );
}

void   DBG_MFHI   () {
	R5900_OP_LOG("mhi %s",  
		DBG_debug_r5900_reg[CURRENT_RD]  );
}


void   DBG_MFLO  () {		
	R5900_OP_LOG("mflo %s",  
		DBG_debug_r5900_reg[CURRENT_RD]  );
}


void   DBG_MOVN() {
	R5900_OP_LOG("movn %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}


void   DBG_MOVZ() {		
	R5900_OP_LOG("movz %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}


void   DBG_MTHI  () {	
	R5900_OP_LOG("mthi %s",  
		DBG_debug_r5900_reg[CURRENT_RS]  );
}

void   DBG_MTLO  () {		
	R5900_OP_LOG("mtlo %s",  
		DBG_debug_r5900_reg[CURRENT_RS]  );
}


void   DBG_MULT     () {
	R5900_OP_LOG("mult %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_MULTU() {		
	R5900_OP_LOG("multu %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}


void   DBG_NOP   () {   R5900_OP_LOG("nop");    }


void   DBG_NOR   () {
	R5900_OP_LOG("nor %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );

}


void   DBG_OR () {
	R5900_OP_LOG("or %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}


void    DBG_ORI () {
	R5900_OP_LOG("ori %s, %s, 0x%4.4lx",
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void    DBG_PREF () {	R5900_OP_LOG("pref"	);}

void    DBG_SB     () {
	R5900_OP_LOG("sb %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}


void    DBG_SD() {
	R5900_OP_LOG("sd %s, 0x%4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_SDL() {
	R5900_OP_LOG("sdl %s, 0x%4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_SDR() {
	R5900_OP_LOG("sdr %s, 0x%4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void    DBG_SH    () {
	R5900_OP_LOG("sh %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}


void   DBG_SLL() {
	R5900_OP_LOG("sll %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA );
}


void   DBG_SLLV () {		
	R5900_OP_LOG("sllv %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}

void   DBG_SLT () {
	R5900_OP_LOG("slt %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT]);
}


void    DBG_SLTI() {
	R5900_OP_LOG("slti %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void    DBG_SLTIU() {
	R5900_OP_LOG("sltiu %s, %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM);
}


void   DBG_SLTU   () {
	R5900_OP_LOG("sltu %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT]);
}


void   DBG_SRA  () {
	R5900_OP_LOG("sra %s, %s, 0x%2.2x",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA );
}

void   DBG_SRAV () {		
	R5900_OP_LOG("srav %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}


void   DBG_SRL   () {
	R5900_OP_LOG("srl %s, %s, %ld",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], CURRENT_SA );
}


void   DBG_SRLV () {	
	R5900_OP_LOG("srlv %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RT], DBG_debug_r5900_reg[CURRENT_RS] );
}


void   DBG_SUB () {
	R5900_OP_LOG("sub %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD],DBG_debug_r5900_reg[CURRENT_RS],DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_SUBU   () {
	R5900_OP_LOG("subu %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD],DBG_debug_r5900_reg[CURRENT_RS],DBG_debug_r5900_reg[CURRENT_RT] );
}


void    DBG_SW   () {
	R5900_OP_LOG("sw %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_SWL() {
	R5900_OP_LOG("swl %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}

void DBG_SWR() {
	R5900_OP_LOG("swr %s, 0x%4.4lx(%s)",  
		DBG_debug_r5900_reg[CURRENT_RT], (long)CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}


void   DBG_SYNC  () {R5900_OP_LOG("sync");}


void   DBG_SYSCALL() {R5900_OP_LOG("syscall");}


void   DBG_TEQ() 	{
	R5900_OP_LOG("teq %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_TEQI() 	{
	R5900_OP_LOG("teqi %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}


void   DBG_TGE() 	{
	R5900_OP_LOG("tge %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_TGEI() 	{
	R5900_OP_LOG("tgei %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void   DBG_TGEIU() 	{
	R5900_OP_LOG("tgeiu %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void   DBG_TGEU() 	{
	R5900_OP_LOG("tgeu %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_TLT() 	{
	R5900_OP_LOG("tlt %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_TLTI() 	{
	R5900_OP_LOG("tlti %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void   DBG_TLTIU() 	{
	R5900_OP_LOG("tltiu %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}

void   DBG_TLTU() 	{
	R5900_OP_LOG("tltu %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_TNE() 	{
	R5900_OP_LOG("tne %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void   DBG_TNEI() 	{
	R5900_OP_LOG("tnei %s, 0x%4.4lx",  
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM );
}


void   DBG_XOR  () {
	R5900_OP_LOG("xor %s, %s, %s",  
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}


void    DBG_XORI () {
	R5900_OP_LOG("xori %s, %s, 0x%4.4llx",  
		DBG_debug_r5900_reg[CURRENT_RT],DBG_debug_r5900_reg[CURRENT_RS],CURRENT_IMM );
}

/*****************************************************************************************************************
								EE SPECIFIC INSTRUCTION SET
*****************************************************************************************************************/

void    DBG_SPECIAL2()	{	DBG_special2_opc[(_OPCODE_  & 0x3F)](); }

void 	DBG_MMI0()		{	DBG_Special2_MMI0[((_OPCODE_ >> 6)  & 0x1F)]();}
 
void 	DBG_MMI2()		{	DBG_Special2_MMI2[((_OPCODE_ >> 6)  & 0x1F)]();}

void 	DBG_MMI1()		{	DBG_Special2_MMI1[((_OPCODE_ >> 6)  & 0x1F)]();}

void 	DBG_MMI3()		{	DBG_Special2_MMI3[((_OPCODE_ >> 6)  & 0x1F)]();}




void	DBG_DIV1	( void )	{		
	R5900_OP_LOG("div1 %s, %s", 
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}
 

void	DBG_DIVU1	( void )	{	
	R5900_OP_LOG("divu1 %s, %s", 
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void    DBG_LQ		( void )	{	
	R5900_OP_LOG("lq %s, 0x%4.4llx( %s )", 
		DBG_debug_r5900_reg[CURRENT_RT], CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}


void	DBG_MADD	( void )	{	
	R5900_OP_LOG("madd %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void	DBG_MADD1	( void )	{		
	R5900_OP_LOG("madd1 %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void	DBG_MADDU	( void )	{		
	R5900_OP_LOG("maddu %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void	DBG_MADDU1	( void )	{		
	R5900_OP_LOG("maddu1 %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD], DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_MFHI1	( void )	{	
	R5900_OP_LOG("mfhi1 %s",
	DBG_debug_r5900_reg[CURRENT_RD]  );
}


void 	DBG_MFLO1	( void )	{	
	R5900_OP_LOG("mflo1 %s",
		DBG_debug_r5900_reg[CURRENT_RD]  );
}


void 	DBG_MFSA	( void )	{		
	R5900_OP_LOG("mfsa %s",
		DBG_debug_r5900_reg[CURRENT_RD]  );
}


void 	DBG_MTHI1	( void )	{		
	R5900_OP_LOG("mthi1 %s",
		DBG_debug_r5900_reg[CURRENT_RS] );
}

void 	DBG_MTLO1	( void )	{	
	R5900_OP_LOG("mtlo1 %s",
		DBG_debug_r5900_reg[CURRENT_RS] );
} 


void 	DBG_MTSA	( void )	{		
	R5900_OP_LOG("mtsa %s",
		DBG_debug_r5900_reg[CURRENT_RS]  );
}


void 	DBG_MTSAB	( void )	{		
	R5900_OP_LOG("mtsab %s, 0x%4.4lx",
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM  );
}


void 	DBG_MTSAH 	( void )	{		
	R5900_OP_LOG("mtsah %s, 0x%4.4lx",
		DBG_debug_r5900_reg[CURRENT_RS], CURRENT_IMM  );
}

void	DBG_MULT1	( void )	{	

	R5900_OP_LOG("mult1 %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void 	DBG_MULTU1	( void )	{	
	R5900_OP_LOG("multu1 %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PABSH	( void )	{		
	R5900_OP_LOG("pabsh %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
}

void 	DBG_PABSW	( void )	{		
	R5900_OP_LOG("pabsw %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PADDB	( void )	{		
	R5900_OP_LOG("paddb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PADDH	( void )	{		
	R5900_OP_LOG("paddh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 
 

void 	DBG_PADDSB	( void )	{		
	R5900_OP_LOG("paddsb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

  
void 	DBG_PADDSW	( void )	{		
	R5900_OP_LOG("paddsw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 
 

void 	DBG_PADDSH	( void )	{		
	R5900_OP_LOG("paddsh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 



void 	DBG_PADDUB	( void )	{		
	R5900_OP_LOG("paddub %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PADDUH	( void )	{		
	R5900_OP_LOG("padduh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 



void 	DBG_PADDUW	( void )	{	
	R5900_OP_LOG("padduw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PADDW	( void )	{		
	R5900_OP_LOG("paddw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  


void 	DBG_PADSBH	( void )	{		
	R5900_OP_LOG("padsbh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PAND	( void )	{	
	R5900_OP_LOG("pand %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PCEQH	( void )	{		
	R5900_OP_LOG("pceqh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PCEQW	( void )	{		
	R5900_OP_LOG("pceqw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PCEQB	( void )	{		
	R5900_OP_LOG("pceqb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PCGTB	( void )	{		
	R5900_OP_LOG("pcgtb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PCGTH	( void )	{		
	R5900_OP_LOG("pcgth %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PCGTW	( void )	{		
	R5900_OP_LOG("pcgtw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 
 
void 	DBG_PCPYH	( void )	{	
	R5900_OP_LOG("pcpyh %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PCPYLD	( void )	{	
	R5900_OP_LOG("ppyld %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PCPYUD	( void )	{	
	R5900_OP_LOG("ppyud %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PDIVBW	( void )	{		
	R5900_OP_LOG("pdivbw %s, %s",
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PDIVUW	( void )	{		
	R5900_OP_LOG("pdivuw %s, %s",
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 
 
void 	DBG_PDIVW	( void )	{		
	R5900_OP_LOG("pdivw %s, %s",
		DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PEXCH	( void )	{		
	R5900_OP_LOG("pexch %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PEXCW	( void )	{		
	R5900_OP_LOG("pexcw %s, %s",
	DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PEXEH	( void )	{		
	R5900_OP_LOG("pexeh %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
}   

void 	DBG_PEXEW	( void )	{	
	R5900_OP_LOG("pexew %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PEXT5	( void )	{		
	R5900_OP_LOG("pext5 %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PEXTLB	( void )	{	
	R5900_OP_LOG("pextlb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PEXTLH		( void )	{		
	R5900_OP_LOG("pextlh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PEXTLW	( void )	{		
	R5900_OP_LOG("pextlw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PEXTUB	( void )	{		
	R5900_OP_LOG("pextub %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PEXTUH	( void )	{		
	R5900_OP_LOG("pextuh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PEXTUW	( void )	{	
	R5900_OP_LOG("pextuw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PHMADH	( void )	{		
	R5900_OP_LOG("phmadh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PHMSBH	( void )	{		
	R5900_OP_LOG("phmsbh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}

void 	DBG_PINTH	( void )	{		
	R5900_OP_LOG("pinth %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PINTEH	( void )	{		
	R5900_OP_LOG("pinteh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void	DBG_PLZCW	( void )	{	
	R5900_OP_LOG("plzcw %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS] );
} 

void 	DBG_PMADDH	( void )	{		
	R5900_OP_LOG("pmaddh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PMADDUW	( void )	{		
	R5900_OP_LOG("pmadduw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PMADDW	( void )	{		
	R5900_OP_LOG("pmaddw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PMAXW	( void )	{		
	R5900_OP_LOG("pmaxw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PMAXH	( void )	{		
	R5900_OP_LOG("pmaxh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PMFHI	( void )	{		
	R5900_OP_LOG("pmfhi %s",
		DBG_debug_r5900_reg[CURRENT_RD]  );
} 

void 	DBG_PMFHL	( void )	{	
	R5900_OP_LOG("pmfhl %s",
		DBG_debug_r5900_reg[CURRENT_RD]  );
} 

void 	DBG_PMFLO	( void )	{		
	R5900_OP_LOG("pmflo %s",
		DBG_debug_r5900_reg[CURRENT_RD]  );
} 

void 	DBG_PMINW	( void )	{		
	R5900_OP_LOG("pminw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PMINH	( void )	{		
	R5900_OP_LOG("pminh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PMSUBH	( void )	{		
	R5900_OP_LOG("pmsubh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PMSUBW	( void )	{		
	R5900_OP_LOG("pmsubw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PMTHI	( void )	{		
	R5900_OP_LOG("pmthi %s",
		DBG_debug_r5900_reg[CURRENT_RS] );
} 

void 	DBG_PMTHL	( void )	{		
	R5900_OP_LOG("pmthl %s",
		DBG_debug_r5900_reg[CURRENT_RS] );
} 

void 	DBG_PMTLO	( void )	{	
	R5900_OP_LOG("pmtlo %s",
		DBG_debug_r5900_reg[CURRENT_RS] );
} 

void 	DBG_PMULTH	( void )	{		
	R5900_OP_LOG("pmulth %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PMULTUW	( void )	{		
	R5900_OP_LOG("pmultuw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PMULTW	( void )	{		
	R5900_OP_LOG("pmultw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PNOR	( void )	{		
	R5900_OP_LOG("pnor %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_POR		( void )	{	
	R5900_OP_LOG("por %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PPAC5	( void )	{	
	R5900_OP_LOG("ppac5 %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PPACB	( void )	{	
	R5900_OP_LOG("ppacb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PPACH	( void )	{	
	R5900_OP_LOG("ppach %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}   


void 	DBG_PPACW	( void )	{		
	R5900_OP_LOG("ppacw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PREVH	( void )	{		
	R5900_OP_LOG("prevh %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
}

void 	DBG_PROT3W	( void )	{	
	R5900_OP_LOG("prot3w %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSLLH	( void )	{		
	R5900_OP_LOG("prot3w %s, %s, sa",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSLLVW	( void )	{		
	R5900_OP_LOG("psllvw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSLLW	( void )	{		
	R5900_OP_LOG("psllw %s, %s, sa",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
}

void 	DBG_PSRAH	( void )	{		
	R5900_OP_LOG("psrah %s, %s, sa",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSRAVW	( void )	{		
	R5900_OP_LOG("psravw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 


void 	DBG_PSRAW	( void )	{		
	R5900_OP_LOG("psraw %s, %s, sa",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
}

void 	DBG_PSRLH	( void )	{		
	R5900_OP_LOG("psrlh %s, %s, sa",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSRLVW	( void )	{		
	R5900_OP_LOG("psrlvw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSRLW	( void )	{		
	R5900_OP_LOG("psrlw %s, %s, sa",
		DBG_debug_r5900_reg[CURRENT_RD] ,  DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSUBB	( void )	{		
	R5900_OP_LOG("psubb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PSUBH	( void )	{		
	R5900_OP_LOG("psubh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PSUBSB	( void )	{		
	R5900_OP_LOG("psubsb %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PSUBSW	( void )	{		
	R5900_OP_LOG("psubsw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PSUBSH	( void )	{		
	R5900_OP_LOG("psubsh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_PSUBUB	( void )	{		
	R5900_OP_LOG("psubsub %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSUBUH	( void )	{		
	R5900_OP_LOG("psubsuh %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSUBUW	( void )	{		
	R5900_OP_LOG("psubsuw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
} 

void 	DBG_PSUBW	( void )	{	
	R5900_OP_LOG("psubw %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );

} 

void 	DBG_PXOR	( void )	{		
	R5900_OP_LOG("pxor %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
}  

void 	DBG_QFSRV	( void )	{		
	R5900_OP_LOG("qfsrv %s, %s, %s",
		DBG_debug_r5900_reg[CURRENT_RD] , DBG_debug_r5900_reg[CURRENT_RS], DBG_debug_r5900_reg[CURRENT_RT] );
 
}

void 	DBG_SQ	( void )	{	
	R5900_OP_LOG("sq %s, 0x%4.4lx( %s )",
		DBG_debug_r5900_reg[CURRENT_RT], CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}



void DBG_COP2()			{	DBG_cop2_opc[((_OPCODE_)&0x3E00000)>>21]();	}


void DBG_LQC2()		{	
	R5900_OP_LOG("lqc2 %s, %4.4llx(%s)", 
		DBG_d_vf_reg[CURRENT_FT], CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}


void DBG_cop2_QMTC2( ) {
	R5900_OP_LOG("qmtc2 %s, %s",
		DBG_debug_r5900_reg[CURRENT_RT] , DBG_d_vf_reg[CURRENT_FS] );
}



void DBG_SQC2()		{	
	R5900_OP_LOG("sqc2 %s, %4.4llx(%s)", 
		DBG_d_vf_reg[CURRENT_FT], CURRENT_OFFSET, DBG_debug_r5900_reg[CURRENT_BASE] );
}




void DBG_cop2_QMFC2() {
	R5900_OP_LOG("qmfc2 %s, %s", 
		DBG_debug_r5900_reg[CURRENT_RT], DBG_d_vf_reg[CURRENT_FS]  );
}


void DBG_cop2_CFC2() {
	R5900_OP_LOG("cfc2 %s, %s",
		DBG_debug_r5900_reg[CURRENT_RT] , DBG_debug_vu_ccr_reg[CURRENT_ID] );
}

  

void DBG_cop2_CTC2	() {
	R5900_OP_LOG("ctc2 %s, %s",
		DBG_debug_r5900_reg[CURRENT_RT] , DBG_debug_vu_ccr_reg[CURRENT_ID] );
}

    


void DBG_cop2_BC() { 	DBG_cop2_BC2_opc[( _OPCODE_ >>16)& 0x3 ](); }
void DBG_BC2F() { 	R5900_OP_LOG("bc2f");}
void DBG_BC2T() { 	R5900_OP_LOG("bc2t");}
void DBG_BC2FL() { 	R5900_OP_LOG("bc2fl");}
void DBG_BC2TL() { 	R5900_OP_LOG("bc2tl");}


/*****************************************************************************************************************
									COP0 VU0 INSTRUCTION SET
*****************************************************************************************************************/

void DBG_cop2_Vopc() 	{ 
	_VU_OPCODE_ = (_u32)_OPCODE_;
	DBG_cop2_V_opc[((_VU_OPCODE_)&0x3F)]();

} 
 
void DBG_Vopc_t60()	{ 	DBG_cop2_V_t60_opc[((_VU_OPCODE_)&0x7C0)>>6]();	}
void DBG_Vopc_t61()	{ 	DBG_cop2_V_t61_opc[((_VU_OPCODE_)&0x7C0)>>6]();	}
void DBG_Vopc_t62()	{ 	DBG_cop2_V_t62_opc[((_VU_OPCODE_)&0x7C0)>>6]();	}
void DBG_Vopc_t63()	{ 	DBG_cop2_V_t63_opc[((_VU_OPCODE_)&0x7C0)>>6](); }


            
void DBG_VABS()		{ 	
	R5900_OP_LOG("VABS.%s %s.%s, %s.%s ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		);
}


void DBG_VADD()		{ 
	R5900_OP_LOG("VADD.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VADDi()	{ 	
	R5900_OP_LOG("VADDi.%s  %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VADDq()	{ 
	R5900_OP_LOG("VADDq.%s  %s.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 

  
void DBG_VADDbc()	{
	R5900_OP_LOG("VADD%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 
 
 


void DBG_VADDA()	{ 
	R5900_OP_LOG("VADDA.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								 	DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 		DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}  

  
void DBG_VADDAi()	{ 	
	R5900_OP_LOG("VADDAi.%s  ACC.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 

void DBG_VADDAq()	{ 	
	R5900_OP_LOG("VADDAq.%s  ACC.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VADDAbc()	{ 	
	R5900_OP_LOG("VADDA%s.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
							 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 


void DBG_VCALLMS()	{ R5900_OP_LOG("VCALLMS");}	
void DBG_VCALLMSR()	{ R5900_OP_LOG("VCALLMSR");}	


void DBG_VCLIP()	{ 	
	R5900_OP_LOG("VCLIPw.%s   %s.%s, %s.w",
										DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT]
	); 
}


void DBG_VDIV()		{
	R5900_OP_LOG("VDIV  Q  %s.%s, %s.%s ",
			DBG_d_vf_reg[CURRENT_FS], 			DBG_d_fstf_field[ CURRENT_VU_FSF ],
			DBG_d_vf_reg[CURRENT_FT], 			DBG_d_fstf_field[ CURRENT_VU_FTF ]
	);		
}  
   

void DBG_VFTOI0()	{ 
	R5900_OP_LOG("VFTOI0.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
}  


void DBG_VFTOI4()	{ 	
	R5900_OP_LOG("VFTOI4.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
}


void DBG_VFTOI15()	{ 	
	R5900_OP_LOG("VFTOI15.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
}

void DBG_VFTOI12()	{ 	
	R5900_OP_LOG("VFTOI12.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
}
  
void DBG_VIADD()	{ 	
	R5900_OP_LOG("VIADD  %s, %s, %s",
		DBG_debug_vu_ccr_reg[CURRENT_VU_ID],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT] 		
	);
} 


void DBG_VIADDI()	{ 	
	R5900_OP_LOG("VIADDI  %s, %s, 0x%4.4x",
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		((_VU_OPCODE_ >> 6) & 0x1f)		
	);
} 


void DBG_VIAND()	{ 
	R5900_OP_LOG("VIAND  %s, %s, %s",
		DBG_debug_vu_ccr_reg[CURRENT_VU_ID],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT] 		
	);
}  


void DBG_VILWR()	{ 	
	R5900_OP_LOG("VILWR.%s  %s, (%s)%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		DBG_d_dest_field[ CURRENT_VU_DEST ] 		
	);
}

  
void DBG_VIOR()		{ 
	R5900_OP_LOG("VIOR  %s, %s, %s",
		DBG_debug_vu_ccr_reg[CURRENT_VU_ID],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT] 		
	);
}

 
void DBG_VISUB()	{ 
	R5900_OP_LOG("VISUB  %s, %s, %s",
		DBG_debug_vu_ccr_reg[CURRENT_VU_ID],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT] 		
	);
}

 
void DBG_VISWR()	{ 		
	R5900_OP_LOG("VISWR.%s  %s, (%s)%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS], 		
		DBG_d_dest_field[ CURRENT_VU_DEST ] 		
	);
} 
 
     
 
void DBG_VITOF0()	{ 	
	R5900_OP_LOG("VITOF0.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
} 


void DBG_VITOF4()	{ 	
	R5900_OP_LOG("VITOF4.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
}

 
void DBG_VITOF12()	{ 	
	R5900_OP_LOG("VITOF12.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
} 

 
void DBG_VITOF15()	{ 	
	R5900_OP_LOG("VITOF15.%s  %s.%s, %s.%s,",
		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ]
	);
}


void DBG_VLQD()		{ 	
	R5900_OP_LOG("VLQD.%s  %s.%s, (--%s).%s ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 

		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS],DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}  


void DBG_VLQI()		{ 		
	R5900_OP_LOG("VLQI.%s  %s.%s, (%s++).%s ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 

		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS],DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

   
void DBG_VMADD()	{ 	
	R5900_OP_LOG("VMADD.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMADDi()	{ 	
	R5900_OP_LOG("VMADDi.%s  %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMADDq()	{ 	
	R5900_OP_LOG("VMADDq.%s  %s.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMADDbc()	{ 
	R5900_OP_LOG("VMADDA%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 


void DBG_VMADDA()	{ 	
	R5900_OP_LOG("VMADDA.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								 	DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 		DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VMADDAi()	{ 	
	R5900_OP_LOG("VMADDAi.%s  ACC.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VMADDAq()	{ 
	R5900_OP_LOG("VMADDAq.%s  ACC.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMADDAbc()	{  
	R5900_OP_LOG("VMADDA%s.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
							 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
}


void DBG_VMAX()		{ 	
	R5900_OP_LOG("VMAX.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMAXi()	{ 	
	R5900_OP_LOG("VMAXi.%s  %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
										 
		); 
} 


void DBG_VMAXbc()	{ 	
	R5900_OP_LOG("VMAX%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 

void DBG_VMFIR()	{ 	
	R5900_OP_LOG("VMFIR.%s  %s.%s, %s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IS]
		); 

}
void DBG_VMINI()	{ 	
	R5900_OP_LOG("VMINI.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMINIi()	{ 
	R5900_OP_LOG("VMINIi.%s %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMINIbc()	{ 	
	R5900_OP_LOG("VMINI%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 


void DBG_VMOVE()	{ 
	R5900_OP_LOG("VMOVE.%s  %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}  


void DBG_VMR32()	{ 	
	R5900_OP_LOG("VMR32.%s  %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 
 

void DBG_VMSUB()	{ 		
	R5900_OP_LOG("VMSUB.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

 
void DBG_VMSUBi()	{ 	
	R5900_OP_LOG("VMSUBi.%s  %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VMSUBq()	{ 
	R5900_OP_LOG("VMSUBq.%s  %s.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMSUBbc()	{	
	R5900_OP_LOG("VMSUB%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
}  
 

void DBG_VMSUBA()	{ 	
	R5900_OP_LOG("VMSUBA.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								 	DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 		DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VMSUBAi()	{ 		
	R5900_OP_LOG("VMSUBAi.%s  ACC.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMSUBAq()	{ 		
	R5900_OP_LOG("VMSUBAq.%s  ACC.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

 
void DBG_VMSUBAbc()	{ 	
	R5900_OP_LOG("VMSUBA%s.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
							 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
}

 
void DBG_VMTIR()	{ 	
	R5900_OP_LOG("VMTIR %s, %s.%s",
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_fstf_field[ CURRENT_VU_FSF ]
		);
}  


void DBG_VMUL(){
	R5900_OP_LOG("VMUL.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}
 

void DBG_VMULi()	{ 	
	R5900_OP_LOG("VMULi.%s  %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VMULq()	{ 
	R5900_OP_LOG("VMULq.%s  %s.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMULbc()	{
	R5900_OP_LOG("VMUL%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
	); 
} 

 
void DBG_VMULA()	{		
	R5900_OP_LOG("VMULA.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								 	DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 		DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VMULAi()	{ 		
	R5900_OP_LOG("VMULAi.%s  ACC.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

  
void DBG_VMULAq()	{ 	
	R5900_OP_LOG("VMULAq.%s  ACC.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VMULAbc()	{ 
	R5900_OP_LOG("VMULA%s.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
							 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
}


void DBG_VNOP()		{ 	
	R5900_OP_LOG( "VNOP"   );
} 


void DBG_VOPMULA()	{ 	
	R5900_OP_LOG("VOPMULA.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
							 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
}  


void DBG_VOPMSUB()	{ 	
	R5900_OP_LOG("VOPMSUB.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 
   
 
void DBG_VRGET()	{ 		
	R5900_OP_LOG("VRGET.%  %s.%s, R ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_fstf_field[ CURRENT_VU_FSF ]
		); 
} 

	
void DBG_VRINIT()	{
	R5900_OP_LOG("VRINIT R  %s.%s ",
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_fstf_field[ CURRENT_VU_FSF ]
		); 
}  

		
void DBG_VRNEXT()	{ 	
	R5900_OP_LOG("VRNEXT.%  %s.%s, R ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_fstf_field[ CURRENT_VU_FSF ]
		); 
}  


void DBG_VRSQRT()	{
	R5900_OP_LOG("VSQRT Q  %s.%s %s.%s",
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_fstf_field[ CURRENT_VU_FSF ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_fstf_field[ CURRENT_VU_FTF ]
		); 
}  


void DBG_VRXOR()	{ 	
	R5900_OP_LOG("VRXOR R  %s.%s ",
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_fstf_field[ CURRENT_VU_FSF ]
		);
} 


void DBG_VSQD()		{ 		
	R5900_OP_LOG("VSQD.%s  %s.%s, (--%s).%s ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 

		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT],DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VSQI()		{ 
	R5900_OP_LOG("VSQI.%s  %s.%s, (%s++).%s ",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 

		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_debug_vu_ccr_reg[CURRENT_VU_IT],DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}


void DBG_VSQRT()	{ 	
	R5900_OP_LOG("VSQRT Q  %s.%s",
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_fstf_field[ CURRENT_VU_FTF ]
		); 
}


void DBG_VSUB()		{ 	
	R5900_OP_LOG("VSUB.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FT], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VSUBi()	{ 		
	R5900_OP_LOG("VSUBi.%s  %s.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

 
void DBG_VSUBq()	{ 	
	R5900_OP_LOG("VSUBq.%s  %s.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], DBG_d_vf_reg[CURRENT_FD], DBG_d_dest_field[ CURRENT_VU_DEST ],
										 DBG_d_vf_reg[CURRENT_FS], DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
} 


void DBG_VSUBbc()	{ 
	R5900_OP_LOG("VSUB%s.%s  %s.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
		DBG_d_vf_reg[CURRENT_FD], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
} 


 

void DBG_VSUBA()	{ 		
	R5900_OP_LOG("VSUBA.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								 	DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 		DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 		DBG_d_dest_field[ CURRENT_VU_DEST ]
	); 
}

  
void DBG_VSUBAi()	{ 	
	R5900_OP_LOG("VSUBAi.%s  ACC.%s, %s.%s, I",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

  
void DBG_VSUBAq()	{ 	
	R5900_OP_LOG("VSUBAq.%s  ACC.%s, %s.%s, Q",
		DBG_d_dest_field[ CURRENT_VU_DEST ], 
								DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 	DBG_d_dest_field[ CURRENT_VU_DEST ]
		); 
}

  
void DBG_VSUBAbc()	{ 	
	R5900_OP_LOG("VSUBA%s.%s  ACC.%s, %s.%s, %s.%s",
		DBG_d_bc_field[ CURRENT_VU_BC ],	DBG_d_dest_field[ CURRENT_VU_DEST ], 
							 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FS], 			DBG_d_dest_field[ CURRENT_VU_DEST ],
		DBG_d_vf_reg[CURRENT_FT], 			DBG_d_bc_field[ CURRENT_VU_BC ]
		); 
}    
  

void DBG_VWAITQ()	{ 	R5900_OP_LOG( "VWAITQ  "   );}








/*************************************************************************/



/* Main CPU function*/
void DisasmOpcode (  ) {

	if ( _OPCODE_ != 0 ) DBG_normal_opc[((_OPCODE_ >> 26) & 0x3F)]();	//Execute the current opcode
	else DBG_NOP();
}


