//---------------------------------------------------------------------------


#pragma hdrstop

#include <windows.h>
#include <stdlib.h>




#include "../nsx2.h"
#include "../_Debuger/debuger.h"


#include "FormMainwindow.h"
#include "Deci2.h"
#include "Netmp.h"
#include "Dbgp.h"
#include "Ttpy.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
/* Functions in DllMain.cpp */
void	WriteToMemory( int space, int align,  __int32 adress,  __int32 size, int VUID, char * Src );
int		ReadFromMemory( int space, int align,  __int32 adress,  __int32 size, int VUID, char * Dst );
void	Debug_Run ( __int32 EntryPoint, __int32 GP_reg ) ;

void DBGP_Log ( char * ftext  , ...   ) {
	char LogText[ 1024 ];
    char LogText2[ 1024 ];

    va_list ap;
   	va_start (ap, ftext);
   	vsprintf (LogText, ftext, ap);
   	va_end (ap);

  	sprintf(LogText2,"[DBGP]%s",LogText);
    MainWindow->Memo->Lines->Add( AnsiString(LogText2).c_str() );

   	sprintf(LogText,"[RDBG]%s\n",LogText2);
    SendPacket_TttpyMessage( LogText );

}



void	DecodeESDbgp( ) {

	DBGPHEAD	*DbgpHdr;
    DBGP_MEM    *DbgpMem;
    DBGP_RUN    *DbgpRun;
    DBGP_REG	*DbgpReg;

    int		ReadSize = 0;
    int		Pad_Align;

    char	*MemDst;
    char	*MemSrc;


	__int64		SavedPC;

    DbgpHdr = ( DBGPHEAD *)( InBuf + DECI2HEAD_SZ );
    InBuf_done = DECI2HEAD_SZ + DBGPHEAD_SZ;
/*
#ifdef  DBGP_LOG
        	DBGP_LOG( "[E] Id:%d, Type:0x%2.2x, Code:0x%2.2x, Result:0x%2.2x, Count:%d",
               DbgpHdr->id, DbgpHdr->type,DbgpHdr->code,DbgpHdr->result,DbgpHdr->count);
#endif
*/


	switch ( DbgpHdr->type ) {
    	case DBGP_TYPE_GETCONF :
			InBuf_done = InBuf_done +  DBGP_CONF_SZ;
  			CreatePacket_ESDbgp ( DBGP_TYPE_GETCONFR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]Get Configuration : %d",DbgpHdr->id);
#endif

  		break;



		case DBGP_TYPE_RDMEM:
        	DbgpMem = ( DBGP_MEM *)( InBuf + DECI2HEAD_SZ + DBGPHEAD_SZ );

			switch( DbgpMem->align ) {
           		case DBGP_ALIGN_DOUBLE	: Pad_Align = 4; 			break;
            	case DBGP_ALIGN_QWORD	: Pad_Align = 12; 			break;
            	case DBGP_ALIGN_1KB		: Pad_Align = 1024 - 28; 	break;
            	default 				: Pad_Align = 0; 			break;
        	}


			MemDst = (char *)OutBuf + ((DECI2HEAD_SZ + DBGPHEAD_SZ + DBGP_MEM_SZ + (1 << DbgpMem->align) - 1) & (0xFFFFFFFF << DbgpMem->align));

			ReadSize = ReadFromMemory( DbgpMem->space, DbgpMem->align, DbgpMem->address,
            	DbgpMem->length, DbgpHdr->id,
                MemDst );


			CreatePacket_ESDbgp ( DBGP_TYPE_RDMEMR , ReadSize + Pad_Align );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]ReadMem  T:%d Add:0x%8.8x Size:0x%4.4x",
            	DbgpMem->space, DbgpMem->address, DbgpMem->length );
#endif


        break;



		case DBGP_TYPE_WRMEM :

	        DbgpMem = ( DBGP_MEM *)( InBuf + DECI2HEAD_SZ + DBGPHEAD_SZ );


			MemSrc = (char *)InBuf + ((DECI2HEAD_SZ + DBGPHEAD_SZ+DBGP_MEM_SZ + (1 << DbgpMem->align) - 1) & (0xFFFFFFFF << DbgpMem->align));

			WriteToMemory( DbgpMem->space, DbgpMem->align, DbgpMem->address,
            	DbgpMem->length, DbgpHdr->id,
                MemSrc );

   			CreatePacket_ESDbgp ( DBGP_TYPE_WRMEMR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]WriteMem T:%d Add:0x%8.8x Size:0x%4.4x",
            	DbgpMem->space, DbgpMem->address, DbgpMem->length );
#endif
 		break;



		case DBGP_TYPE_RUN:
	        DbgpRun = ( DBGP_RUN *)( InBuf + DECI2HEAD_SZ + DBGPHEAD_SZ );

			FromEmu->MipsCpu->GPR[ CPU_REG_GP ].lo 	= DbgpRun->gp;
    		FromEmu->MipsCpu->PC 					= DbgpRun->entry;

			FromEmu->MipsCpu->halt = 0;

   			CreatePacket_ESDbgp ( DBGP_TYPE_RUNR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]Run Entry:0x%8.8x gp:0x%8.8x Args:%d",
            	   DbgpRun->entry, DbgpRun->gp, DbgpRun->argc	);
#endif
        break;



		case DBGP_TYPE_BREAK:

			FromEmu->MipsCpu->halt = 1;
        	while ( FromEmu->MipsCpu->halt == 0 ) { };

			SavedPC = (__int64)FromEmu->MipsCpu->PC;
            FromEmu->MipsCpu->CPR0[13][0] = (__int64)0x24;
            FromEmu->MipsCpu->CPR0[14][0] = SavedPC;


   			CreatePacket_ESDbgp ( DBGP_TYPE_BREAKR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]Break");
#endif
        break;


		case DBGP_TYPE_CONTINUE:

			switch ( DbgpHdr->code ) {
            	case DBGP_CODE_CONT :

					SavedPC = (__int64)FromEmu->MipsCpu->CPR0[14][0];
                    FromEmu->MipsCpu->PC = SavedPC;
					FromEmu->MipsCpu->halt = 0;

					CreatePacket_ESDbgp ( DBGP_CODE_CONTR , DbgpHdr->id );
#ifdef  DBGP_LOG
        			DBGP_LOG( "[E]Continue");
#endif

				break;

				case DBGP_CODE_STEP :

					SavedPC = (__int64)FromEmu->MipsCpu->CPR0[14][0];
                    FromEmu->MipsCpu->PC = SavedPC;
                    FromEmu->MipsCpu->halt = 2;

                    CreatePacket_ESDbgp ( DBGP_CODE_STEPR , DbgpHdr->id );

#ifdef  DBGP_LOG
        			DBGP_LOG( "[E]Continue ( Step ) : %d",DbgpHdr->count );
#endif


				break;

				case DBGP_CODE_NEXT :

					SavedPC = (__int64)FromEmu->MipsCpu->CPR0[14][0];
                    FromEmu->MipsCpu->PC = SavedPC;
                    FromEmu->MipsCpu->halt = 2;

                    CreatePacket_ESDbgp ( DBGP_CODE_NEXTR , DbgpHdr->id );

#ifdef  DBGP_LOG
        			DBGP_LOG( "[E]Continue ( Next ) : %d",DbgpHdr->count );
#endif


				break;


                default :
#ifdef  DBGP_LOG
        			DBGP_LOG( "[E]Continue:ERROR : %d",DbgpHdr->count );
#endif
                    CreatePacket_ESDbgp ( DBGP_CODE_CONT_ERROR , DbgpHdr->id );
				break;

            }

	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

		break;



		case DBGP_TYPE_GETREG:
   			CreatePacket_ESDbgp ( DBGP_TYPE_GETREGR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);

#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]GetRegs Id:%d, Count:%d",DbgpHdr->id, DbgpHdr->count);
#endif
        break;


		case DBGP_TYPE_PUTREG:
   			CreatePacket_ESDbgp ( DBGP_TYPE_PUTREGR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ESDBGP);
#ifdef  DBGP_LOG
        	DBGP_LOG( "[E]PutRegs Id:%d, Count:%d",DbgpHdr->id, DbgpHdr->count);
#endif

        break;


		default:
#ifdef  DBGP_LOG
        	DBGP_LOG("[E]Type UNKNOW: 0x%x" ,DbgpHdr->type  );
#endif
			InBuf_done = InBuf_Lenght;
		break;



	}



}


void	CreatePacket_ESDbgp ( int fCode, int fParam ) {
	int	boucle;

    int				BuffLength;

    DBGP_MEM		*DBGPMen_In;
    DBGPHEAD		*DBGPHdr_In;

	DBGPHEAD		*DBGPHdr;
    DBGP_CONF		*DBGPConf;
    DBGP_MEM		*DBGPMen;
    DBGP_REG		*DBGPReg;
    DBGP_REG		*DBGPReg_Out;

    _u128v2			*val128v2;
    _u128			*val128;
    char *			RegValue;


    DBGPHdr 	= ( DBGPHEAD *) ( OutBuf + DECI2HEAD_SZ );
    DBGPConf 	= ( DBGP_CONF *)( OutBuf + DECI2HEAD_SZ + DBGPHEAD_SZ);
    DBGPMen		= ( DBGP_MEM *) ( OutBuf + DECI2HEAD_SZ + DBGPHEAD_SZ);

    DBGPHdr_In 	= ( DBGPHEAD *) ( InBuf + DECI2HEAD_SZ );
    DBGPMen_In 	= ( DBGP_MEM *)	( InBuf + DECI2HEAD_SZ + DBGPHEAD_SZ);

    OutBuf_Lenght = DECI2HEAD_SZ + DBGPHEAD_SZ ;



    switch( fCode ) {
        case DBGP_TYPE_GETCONFR:
//        	DBGPHdr->id		=
            DBGPHdr->type	= DBGP_TYPE_GETCONFR;
            DBGPHdr->code	= DBGP_TYPE_GETCONFR;
			DBGPHdr->result	= DBGP_RESULT_GOOD;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;

            DBGPConf->major_ver 		= 3;
            DBGPConf->minor_ver 		= 0;
			DBGPConf->target_id 		= DECI2_PROTO_ESDBGP;
            DBGPConf->reserved1 		= 0;
			DBGPConf->mem_align 		= 0x41F;
            DBGPConf->reserved2			= 1;
			DBGPConf->reg_size			= 7;
			DBGPConf->nreg 				= 32;
			DBGPConf->nbrkpt			= 32;
			DBGPConf->ncont				= 1;
			DBGPConf->nstep				= 0xFF;
			DBGPConf->nnext				= 0xFF;
			DBGPConf->mem_limit_align 	= 0x1F;
			DBGPConf->mem_limit_size    = 0x400;
  			DBGPConf->run_stop_state 	= 2;
			DBGPConf->hdbg_area_addr    = 0x80020c70;
			DBGPConf->hdbg_area_size 	= 0x100;

            OutBuf_Lenght = DECI2HEAD_SZ + DBGPHEAD_SZ + DBGP_CONF_SZ;

		break;

        case DBGP_TYPE_WRMEMR:
        	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_WRMEMR;
            DBGPHdr->code	= DBGP_TYPE_WRMEMR;
			DBGPHdr->result	= DBGP_RESULT_GOOD;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;

            DBGPMen->space 		=  DBGPMen_In->space;
            DBGPMen->align 		=  DBGPMen_In->align;
            DBGPMen->reserved 	=  DBGPMen_In->reserved;
            DBGPMen->address 	=  DBGPMen_In->address;
            DBGPMen->length 	=  DBGPMen_In->length;

			OutBuf_Lenght = DECI2HEAD_SZ + DBGPHEAD_SZ + DBGP_MEM_SZ;
        break;

        case DBGP_TYPE_RDMEMR:
        	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_RDMEMR;
            DBGPHdr->code	= DBGP_TYPE_RDMEMR;
			DBGPHdr->result	= DBGP_RESULT_GOOD;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;

            DBGPMen->space 		=  DBGPMen_In->space;
            DBGPMen->align 		=  DBGPMen_In->align;
            DBGPMen->reserved 	=  DBGPMen_In->reserved;
            DBGPMen->address 	=  DBGPMen_In->address;
            DBGPMen->length 	=  DBGPMen_In->length;


			OutBuf_Lenght = DECI2HEAD_SZ + DBGPHEAD_SZ + DBGP_MEM_SZ + fParam;
        break;



        case DBGP_TYPE_RUNR:
        	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_RUNR;
            DBGPHdr->code	= DBGPHdr_In->code;
			DBGPHdr->result	= DBGP_RESULT_GOOD;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;


 		break;

        case DBGP_TYPE_BREAKR:
        	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_BREAKR;
            DBGPHdr->code	= DBGPHdr_In->code;
			DBGPHdr->result	= DBGP_RESULT_BREAKED ;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;
 		break;

        case DBGP_TYPE_GETREGR:

			DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_GETREGR;
            DBGPHdr->code	= DBGPHdr_In->code;
			DBGPHdr->result	= DBGP_RESULT_GOOD ;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;

            OutBuf_Lenght = DECI2HEAD_SZ + DBGPHEAD_SZ;

            for ( boucle = 0 ; boucle < DBGPHdr->count ; boucle++ ) {

           		DBGPReg 	= ( DBGP_REG *)	( InBuf + OutBuf_Lenght );
                DBGPReg_Out = ( DBGP_REG *)	( OutBuf + OutBuf_Lenght );

                DBGPReg_Out->kind 		= DBGPReg->kind;
                DBGPReg_Out->number 	= DBGPReg->number ;
                DBGPReg_Out->reserved	= DBGPReg->reserved;

				val128v2 	= ( _u128v2 *) ((char*)( DBGPReg_Out + DBGP_REG_SZ ));
				val128 		= ( _u128 *)   ((char*)( DBGPReg_Out + DBGP_REG_SZ ));
                RegValue	= (char*)( DBGPReg_Out + DBGP_REG_SZ );


                OutBuf_Lenght = OutBuf_Lenght + DBGP_REG_SZ + 16 ;

	            //DumpReceiveData();

                switch( DBGPReg->kind ) {


                	case ESDBGP_KIND_GPR :

						val128->lo = ( _u64)  FromEmu->MipsCpu->GPR[ DBGPReg->number ].lo ;
                        val128->hi = ( _u64)  FromEmu->MipsCpu->GPR[ DBGPReg->number ].hi ;

                    break;

                    case ESDBGP_KIND_HLS:

                        switch ( DBGPReg->number ) {
                            case ESDBGP_NUM_HI:
                                val128->hi = ( __int64) FromEmu->MipsCpu->GPR[ CPU_REG_HI ].lo ;
                            break;

                            case ESDBGP_NUM_LO:
                               val128->hi = ( __int64) FromEmu->MipsCpu->GPR[ CPU_REG_LO ].lo ;

                            break;

                            case ESDBGP_NUM_HI1:
                                val128->hi = ( __int64) FromEmu->MipsCpu->GPR[ CPU_REG_HI ].hi ;

                            break;
                            case ESDBGP_NUM_LO1:
                                val128->hi = ( __int64) FromEmu->MipsCpu->GPR[ CPU_REG_LO ].hi ;

                            break;
                            case ESDBGP_NUM_SA:
                               	val128->hi = ( __int64) FromEmu->MipsCpu->SA.lo ;
                            break;


                        	default:
			        			DBGP_LOG("[E][GETREG][KIND_HLS] number Unknow: 0x%x" ,DBGPReg->number  );
                            break;

                        }

                    break;



                    case ESDBGP_KIND_SCR:
                        val128->hi = ( __int64 ) FromEmu->MipsCpu->CPR0[ DBGPReg->number + 1 ][0];
                    break;


					case  ESDBGP_KIND_PCR:		val128v2->b32.w00 = 0;
					break;


					case  ESDBGP_KIND_HDR:		val128v2->b32.w00 = 0;
					break;


					case  ESDBGP_KIND_FPR:
                         val128v2->b32.w02 = (__int32)FromEmu->MipsCpu->FPR1[ DBGPReg->number ] ;
                    break;

					case  ESDBGP_KIND_FPC:
	                      val128v2->b32.w02 = (__int32)FromEmu->MipsCpu->CP1[ DBGPReg->number ] ;
                     break;


					case  ESDBGP_KIND_V0F:
                          val128v2->b32.w00 = (__int32)FromEmu->VectorUnit0->CPR[DBGPReg->number][0]  ;
                          val128v2->b32.w01 = (__int32)FromEmu->VectorUnit0->CPR[DBGPReg->number][1]  ;
                          val128v2->b32.w02 = (__int32)FromEmu->VectorUnit0->CPR[DBGPReg->number][2]  ;
			              val128v2->b32.w03 = (__int32)FromEmu->VectorUnit0->CPR[DBGPReg->number][3]  ;
                    break;




                    case ESDBGP_KIND_V0I:
                          val128v2->b32.w02 = (__int32)FromEmu->VectorUnit0->CCR[DBGPReg->number]   ;
                    break;


					case  ESDBGP_KIND_V1F:
                          val128v2->b32.w00 = (__int32)FromEmu->VectorUnit1->CPR[DBGPReg->number][0]  ;
                          val128v2->b32.w01 = (__int32)FromEmu->VectorUnit1->CPR[DBGPReg->number][1]  ;
                          val128v2->b32.w02 = (__int32)FromEmu->VectorUnit1->CPR[DBGPReg->number][2]  ;
			              val128v2->b32.w03 = (__int32)FromEmu->VectorUnit1->CPR[DBGPReg->number][3]  ;
                    break;



                  case ESDBGP_KIND_V1I:
                         val128v2->b32.w02 = (__int32)FromEmu->VectorUnit1->CCR[DBGPReg->number]   ;

                  break;




                    default:
			        	DBGP_LOG("[E][GETREG] Kind Unknow: 0x%x" ,DBGPReg->kind  );
	           		break;
                }


           	}



		break;


        case DBGP_TYPE_PUTREGR:
        	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_GETREGR;
            DBGPHdr->code	= DBGPHdr_In->code;
			DBGPHdr->result	= DBGP_RESULT_GOOD ;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;

            for ( boucle = 0 ; boucle < DBGPHdr->count ; boucle++ ) {
            	DBGPReg 	= ( DBGP_REG *)	( InBuf + OutBuf_Lenght );
                DBGPReg_Out = ( DBGP_REG *)	( OutBuf + OutBuf_Lenght );

                DBGPReg_Out->kind 		= DBGPReg->kind;
                DBGPReg_Out->number 	= DBGPReg->number;

				val128v2 	= ( _u128v2 *)	( DBGPReg_Out + DBGP_REG_SZ );
				val128 		= ( _u128 *)	( DBGPReg_Out + DBGP_REG_SZ );

                OutBuf_Lenght = OutBuf_Lenght + DBGP_REG_SZ + 16 ;

                switch( DBGPReg->kind ) {

                	case ESDBGP_KIND_GPR :

						FromEmu->MipsCpu->GPR[ DBGPReg->number ].lo = ( __int64)val128->lo  ;
                        FromEmu->MipsCpu->GPR[ DBGPReg->number ].hi = ( __int64)val128->hi  ;

                    break;

/*
                    case ESDBGP_KIND_HLS:

                        switch ( DBGPReg->number ) {
                            case ESDBGP_NUM_HI:


                            break;

                            case ESDBGP_NUM_LO:


                            break;

                            case ESDBGP_NUM_HI1:


                            break;
                            case ESDBGP_NUM_LO1:


                            break;
                            case ESDBGP_NUM_SA:


                            break;


                        	default:
			        			DBGP_LOG("[E][GETREG][KIND_HLS] number Unknow: 0x%x" ,DBGPReg->number  );
                            break;

                        }

                    break;
 */


                    case ESDBGP_KIND_SCR:
                         FromEmu->MipsCpu->CPR0[ DBGPReg->number  ][0] = ( __int32 ) val128->lo ;
                    break;

 /*
					case  ESDBGP_KIND_PCR:



                    break;
*/
/*
					case  ESDBGP_KIND_HDR:

                    break;
*/
/*
					case  ESDBGP_KIND_FPR:



                    break;

					case  ESDBGP_KIND_FPC:



                    break;


					case  ESDBGP_KIND_V0F:



                    break;


 */
/*
                  case ESDBGP_KIND_V0I:


                    break;
*/
 /*

					case  ESDBGP_KIND_V1F:



                    break;



                  case ESDBGP_KIND_V1I:


                    break;

  */


                    default:
			        	DBGP_LOG("[E][PUTREG] Kind Unknow: 0x%x" ,DBGPReg->kind  );
	           		break;
                }


           	}

		break;

		case DBGP_CODE_CONTR :
        	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_CONTINUER;
            DBGPHdr->code	= DBGP_CODE_CONT;
			DBGPHdr->result	= DBGP_RESULT_GOOD;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;
 		break;

		case DBGP_CODE_STEPR:
         	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_CONTINUER;
            DBGPHdr->code	= DBGP_CODE_STEP;
			DBGPHdr->result	= DBGP_RESULT_STEPNEXT;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;
		break;


		case DBGP_CODE_NEXTR:
         	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_CONTINUER;
            DBGPHdr->code	= DBGP_CODE_NEXT;
			DBGPHdr->result	= DBGP_RESULT_STEPNEXT;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;
		break;


		case DBGP_CODE_CONT_ERROR:
         	DBGPHdr->id		= DBGPHdr_In->id;
            DBGPHdr->type	= DBGP_TYPE_CONTINUER;
            DBGPHdr->code	= DBGPHdr_In->code;
			DBGPHdr->result	= DBGP_RESULT_INVALCONT;
            DBGPHdr->count	= DBGPHdr_In->count;
			DBGPHdr->unused	= 0;
		break;


        default:
#ifdef  DBGP_LOG
            DBGP_LOG("[SEND] CODE UNKNOW: 0x%x", fCode );
#endif
		break;

	}



}




/*****************************************************************************/

void	DecodeISDbgp( ) {
	DBGPHEAD 		* DbgpHdr;

    DbgpHdr = ( DBGPHEAD *)( InBuf + InBuf_done );
    InBuf_done = InBuf_done + DBGPHEAD_SZ;

	switch ( DbgpHdr->type ) {
    	case DBGP_TYPE_GETCONF :
#ifdef  DBGP_LOG
        	DBGP_LOG( "[I]Get Configuration : %d",DbgpHdr->id);
#endif

			InBuf_done = InBuf_done +  DBGP_CONF_SZ;
  			CreatePacket_ISDbgp ( DBGP_TYPE_GETCONFR , DbgpHdr->id );
	        SendPacket_Dbgp(DECI2_PROTO_ISDBGP);
  		break;

 		default:
        	DBGP_LOG("[I] CODE UNKNOW: 0x%x",DbgpHdr->type  );
			InBuf_done = InBuf_Lenght;
		break;




	}



}




void	CreatePacket_ISDbgp ( int fCode, int fParam ) {

	DBGPHEAD		*DBGPHdr;
    DBGP_CONF		*DBGPConf;

    DBGPHdr 	= ( DBGPHEAD *) ( OutBuf + DECI2HEAD_SZ );
    DBGPConf 	= ( DBGP_CONF *) ( OutBuf + DECI2HEAD_SZ + DBGPHEAD_SZ);


    OutBuf_Lenght = DECI2HEAD_SZ + DBGPHEAD_SZ ;


    switch( fCode ) {
        case DBGP_TYPE_GETCONFR:
//        	DBGPHdr->id		=
            DBGPHdr->type	= DBGP_TYPE_GETCONFR;
            DBGPHdr->code	= DBGP_TYPE_GETCONFR;
			DBGPHdr->result	= DBGP_RESULT_GOOD;
            DBGPHdr->count	= 0;
			DBGPHdr->unused	= 0;

            DBGPConf->major_ver 		= 3;
            DBGPConf->minor_ver 		= 0;
			DBGPConf->target_id 		= DECI2_PROTO_ISDBGP;
            DBGPConf->reserved1 		= 0;
			DBGPConf->mem_align 		= 0x00F;
            DBGPConf->reserved2			= 1;
			DBGPConf->reg_size			= 5;
			DBGPConf->nreg 				= 62;
			DBGPConf->nbrkpt			= 32;
			DBGPConf->ncont				= 1;
			DBGPConf->nstep				= 0x00;
			DBGPConf->nnext				= 0x00;
			DBGPConf->mem_limit_align 	= 0x07;
			DBGPConf->mem_limit_size    = 0x200;
  			DBGPConf->run_stop_state 	= 1;
			DBGPConf->hdbg_area_addr    = 0x0001E670;
			DBGPConf->hdbg_area_size 	= 0x100;

            OutBuf_Lenght = OutBuf_Lenght + DBGP_CONF_SZ;

		break;



        default:
            DBGP_LOG("[SEND] CODE UNKNOW: 0x%x",fCode );

		break;

	}



}
 






void SendPacket_Dbgp( int fProto) {
	sceDeci2Hdr	*Deci2Hdr;
	sceDeci2Hdr	*Deci2Hdr_In;

	Deci2Hdr 	= ( sceDeci2Hdr *)OutBuf;
	Deci2Hdr_In = ( sceDeci2Hdr *)InBuf;


    Deci2Hdr->proto 	= fProto;
    Deci2Hdr->src 		= Deci2Hdr_In->dest;
    Deci2Hdr->dest 		= Deci2Hdr_In->src;
    Deci2Hdr->len		= OutBuf_Lenght;

	ClientSocket->SendBuf(OutBuf,Deci2Hdr->len);

 /*
  	DBGP_LOG("[SEND] %d bytes",Deci2Hdr->len );
 */
}






char Dbgp_buff[ BUFFER_SIZE ];

void SendPacket_Dbgp_Breaked( ) {
	int SizePacket;

	DBGPHEAD	*DBGPHdr;
	sceDeci2Hdr	*Deci2Hdr;

	Deci2Hdr 	= ( sceDeci2Hdr *)	Dbgp_buff;
    DBGPHdr 	= ( DBGPHEAD *) 	( Dbgp_buff + DECI2HEAD_SZ );
   	SizePacket 	= DECI2HEAD_SZ + DBGPHEAD_SZ ;


    Deci2Hdr->proto 	= DECI2_PROTO_ESDBGP;
    Deci2Hdr->src 		= DECI2_NODE_ID_EE;
    Deci2Hdr->dest 		= DECI2_NODE_ID_HOST;
    Deci2Hdr->len		= SizePacket;


   	DBGPHdr->id			= DBGP_CPUID_CPU;
    DBGPHdr->type		= DBGP_TYPE_BREAKR;
    DBGPHdr->code		= 0;
	DBGPHdr->result		= DBGP_RESULT_BREAKED ;
    DBGPHdr->count		= 0;
	DBGPHdr->unused		= 0;


	DBGP_Log("[SEND]BREAK REQUEST");

	ClientSocket->SendBuf(Dbgp_buff, Deci2Hdr->len);

}


void SendPacket_Dbgp_EndProgram( ) {

/*
  	MUST FIND HOW TO DISCONNECT THE HOST PROPERLY

*/

}


