#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Common.h"

_CDVDinit       CDVDinit;
_CDVDopen       CDVDopen;
_CDVDclose      CDVDclose;
_CDVDshutdown   CDVDshutdown;
_CDVDreadTrack  CDVDreadTrack;
_CDVDgetBuffer  CDVDgetBuffer;
_CDVDgetTN      CDVDgetTN;
_CDVDgetTD      CDVDgetTD;

_CDVDconfigure  CDVDconfigure;
_CDVDtest       CDVDtest;
_CDVDabout      CDVDabout;

_PS2EgetLibType CDVDLibType;
_PS2EgetLibVersion CDVDLibVersion;
_PS2EgetLibName CDVDLibName;


void *CDVDplugin;

void CALLBACK CDVD_configure() {}
void CALLBACK CDVD_about() {}
long CALLBACK CDVD_test() { return 0; }


void *SysLoadSym(void *lib, char *sym) 
{
	void *tmp = GetProcAddress((HINSTANCE)lib, sym);
	return tmp;
}

#define LoadSym(dest, src, name, checkerr) \
    dest = (src) SysLoadSym(drv, name); 

#define LoadCDVDsym1(dest, name) \
	LoadSym(CDVD##dest, _CDVD##dest, name, 1);

#define LoadCDVDsym0(dest, name) \
	LoadSym(CDVD##dest, _CDVD##dest, name, 0); \
	if (CDVD##dest == NULL) CDVD##dest = (_CDVD##dest) CDVD_##dest;

int LoadCDVDplugin(char *filename) 
{
	void *drv;
/*
	CDVDplugin = LoadLibrary(filename);
	if (CDVDplugin == NULL) return 1;
	drv = CDVDplugin;
*/
	CDVDplugin = LoadLibrary(filename);
	if (CDVDplugin == NULL) { SysMessage ("Could Not Load CDVD Plugin %s\n", filename); return 1; }
	drv = CDVDplugin;



	LoadCDVDsym1(init,         "CDVDinit");
	LoadCDVDsym1(shutdown,     "CDVDshutdown");
	LoadCDVDsym1(open,         "CDVDopen");
	LoadCDVDsym1(close,        "CDVDclose");
	LoadCDVDsym1(readTrack,    "CDVDreadTrack");
	LoadCDVDsym1(getBuffer,    "CDVDgetBuffer");
	LoadCDVDsym1(getTN,        "CDVDgetTN");
	LoadCDVDsym1(getTD,        "CDVDgetTD");

	LoadCDVDsym0(configure,    "CDVDconfigure");
	LoadCDVDsym0(about,        "CDVDabout");
	LoadCDVDsym0(test,         "CDVDtest"); 
	CDVDLibType = (_PS2EgetLibType) GetProcAddress((HMODULE)CDVDplugin,"PS2EgetLibType");
	CDVDLibName    = (_PS2EgetLibName) GetProcAddress((HMODULE)CDVDplugin,"PS2EgetLibName");
	CDVDLibVersion = (_PS2EgetLibVersion) GetProcAddress((HMODULE)CDVDplugin,"PS2EgetLibVersion");
	
	return 0;
}