/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Rpc_services.h"

/////////////////////////////////////////////// 0001
void SpuInit(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuInit()\n");
#endif

}

/////////////////////////////////////////////// 0002
int	SpuSetCore(int core){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetCore(%s)\n", core?"CORE1":"CORE0");
#endif

	return 1;
}

/////////////////////////////////////////////// 0005
void SpuSetKey(int H4, int H8){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetKey(on_off=%d, voice_bit=0x%08X)\n", H4, H8);
#endif
}

/*0006	int	SpuSetReverb			(int   H4);
0007	int	SpuClearReverbWorkArea		(int   H4);
*/

/////////////////////////////////////////////// 0008
void SpuSetReverbEndAddr(int H4){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetReverbEndAddr(0x%08X)\n", H4);
#endif
}

/////////////////////////////////////////////// 000A
void SpuSetReverbModeDepth(short H4, short H8){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetReverbModeDepth(left=0x%04X, right=0x%04X)\n", H4, H8);
#endif
}

/*000B	int	SpuSetReverbVoice		(int   H4, int   H8);
000C	int	SpuSetIRQ			(int   H4);
000D	int	SpuSetIRQAddr			(int   H4);
*/

/////////////////////////////////////////////// 000E
int SpuSetTransferMode(int transferMode){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetTransferMode(%s)\n", transferMode?"SPU_TRANSFER_BY_IO":"SPU_TRANSFER_BY_DMA");
#endif

	return (transferMode==SPU_TRANSFER_BY_IO);
}

/////////////////////////////////////////////// 0010
void *SpuSetTransferStartAddr(void *spuAddr){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetTransferStartAddr(0x%06X)\n", spuAddr);
#endif

	return spuAddr;
}

/////////////////////////////////////////////// 0011
int	SpuWrite(void *iopAddr, int	size){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuWrite(0x%06X, %d)\n", iopAddr, size);
#endif

	return 1;
}

/////////////////////////////////////////////// 0012
int	SpuWrite0(int size){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuWrite0(%d)\n", size);
#endif

	return 1;
}

/*0013	int	SpuIsTransferCompleted		(int   H4);
0017	int	SpuGetReverbEndAddr		();
0018	int	SpuWritePartly			(int   H4, int   H8);*/

/////////////////////////////////////////////// 0019
void SpuInitHot(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuInitHot()\n");
#endif

}

/*001A	int	SpuIsReverbWorkAreaReserved	(int   H4);
001B	int	SpuMallocWithStartAddr		(int   H4, int   H8);
001C	int	SpuRead				(int   H4, int   H8);
001D	int	SpuReadDecodedData		(int   H4, int   H8);
001E	int	SpuReserveReverbWorkArea	(int   H4);
0020	int	SpuSetMute			(int   H4);
0021	int	SpuSetNoiseClock		(int   H4);
0022	int	SpuSetNoiseVoice		(int   H4, int   H8);
0023	int	SpuSetPitchLFOVoice		(int   H4, int   H8);
0024	int	SpuStGetStatus			();
0025	int	SpuStGetVoiceStatus		();
*/

/////////////////////////////////////////////// 0100
int	SpuInitMalloc(int   H4){//, &spu_malloc_rec
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuInitMalloc(%d)\n", H4);
#endif

	return 1;
}

/////////////////////////////////////////////// 0101
int	SpuMalloc(int size){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuMalloc(%d)\n", size);
#endif

	return 1;
}

/*0200	int    *...				(int   H4);
...		{
		 gStPtr=SpuStInit(H4);
		 ret=&gStBuff;
		 SpuStSetPreparationFinishedCallback(&spustCB_preparation_finished);
		 SpuStSetTransferFinishedCallback(&spustCB_transfer_finished);
		 SpuStSetStreamFinishedCallback(&spustCB_stream_finished);
		 return &ret;
		}
0201	int	SpuStQuit			();
0202	int    *...				(int   H4, int   H8);
...		{
		 memcpy(gStPtr, &gStBuff, 392);
		 ret=SpuStTransfer(H4, H8);
		 return &ret;
		}
0203	int	SpuStSetCore			(int   H4);
100C	int	SpuGetIRQAddr			();
1010	int	SpuFlush			(int   H4);
1011	void	SpuFree				(int   H4);
1013	int	SpuGetIRQ			();
1014	int	SpuGetMute			();
1015	int	SpuGetNoiseClock		();
1016	int	SpuGetNoiseVoice		();
1017	int	SpuGetPitchLFOVoice		();
1018	int	SpuGetReverb			();
1019	int	SpuGetReverbVoice		();
101A	int	SpuGetTransferMode		();
101B	int	SpuGetTransferStartAddr		();
101C	int	SpuGetKeyStatus			(int   H4);
*/

/////////////////////////////////////////////// 1020
int	SpuAutoDMAWrite(int   H4, int   H8, int   HC){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuAutoDMAWrite(addr=0x%06X, 0x%08X, 0x%08X)\n", H4, H8, HC);
#endif

	return 1;
}

/////////////////////////////////////////////// 1021
void SpuAutoDMAStop(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuAutoDMAStop()\n");
#endif
}

/////////////////////////////////////////////// 1022
int	SpuAutoDMAGetStatus(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuAutoDMAGetStatus()\n");
#endif

	return 1;
}

/*1023	void	SpuSetAutoDMAAttr		(short H4, short H8, short HC, short H10);
1024	void	SpuSetSerialInAttr		(short H4, short H8);
1030	void	...				(int   H4);
...		{
		 gMultiVoiceNum=H4;
		}
1031	void	SpuSetDigitalOut		(int   H4);
4001	char	SsBlockVoiceAllocation		();
4002	void	SsEnd				();
4003	void	SsChannelMute			(short H4, short H8, int   HC);
4004	short	SsGetActualProgFromProg		(short H4, short H8);
4005	int	SsGetChannelMute		(short H4, short H8);
4006	int	SsGetCurrentPoint		(short H4, short H8);
4007	int	SsGetVoiceMask			();
4008	void	SsInit				();
4009	short	SsIsEos				(short H4, short H8);
400A	void	SsAllocateVoices		(uchar H4, uchar H8);
4010	void	SsPitchCorrect			(short H4);
4011	ushort	SsPitchFromNote			(short H4, short H8, uchar HC, uchar H10);
4012	void	SsPlayBack			(short H4, short H8, short HC);
4013	void	SsQueueKeyOn			(int   H4);
4014	void	SsQueueReverb			(int   H4, int   H8);
4015	void	SsQuit				();
4017	void	SsSetTableSize			(&seq_table,short H8,short HC););
4018	void	SsSetTickMode			(int   H4);
4019	void	SsSepClose			(short H4);
4020	short	SsSepOpen			(int  *H4, short H8, short HC);
4021	void	SsSepPause			(short H4, short H8);
4022	void	SsSepPlay			(short H4, short H8, char  HC, short H10);
4023	void	SsSepReplay			(short H4, short H8);
4024	void	SsSepSetAccelerando		(short H4, short H8, int   HC, int   H10);
4025	void	SsSepSetCrescendo		(short H4, short H8, short HC, int   H10);
4026	void	SsSepSetDecrescendo		(short H4, short H8, short HC, int   H10);
4027	void	SsSepSetRitardando		(short H4, short H8, int   HC, int   H10);
4028	void	SsSepSetVol			(short H4, short H8, short HC, short H10);
4029	void	SsSepStop			(short H4, short H8);
4030	void	SsSeqGetVol			(short H4, short H8, int  *HC, int  *H10);
4031	short	SsSeqOpen			(int   H4, short H8);
4032	void	SsSeqPause			(short H4);
4033	void	SsSeqPlayPtoP			(short H4, short H8, int   HC, int   H10, char  HC, short H10);
4034	void	SsSeqReplay			(short H4);
4035	void	SsSeqSetAccelerando		(short H4, int   H8, int   HC);
4036	void	SsSeqSetCrescendo		(short H4, short H8, int   HC);
4037	void	SsSeqSetDecrescendo		(short H4, short H8, int   HC);
4038	void	SsSeqSetRitardando		(short H4, int   H8, int   HC);
4039	void	SsSeqSetNext			(short H4, short H8);
4040	void	SsSeqCalledTbyT			();
4041	void	SsSeqClose			(short H4);
4042	void	SsSeqPlay			(short H4, char  H8, short HC);
4043	void	SsSeqSetVol			(short H4, short H8, short HC);
4044	void	SsSeqSkip			(short H4, short H8, char  HC, short H10);
4045	void	SsSeqStop			(short H4);
4046	void	SsSetAutoKeyOffMode		(short H4);
4047	void	SsSetCurrentPoint		(short H4, short H8, int   HC);
4048	void	SsSetLoop			(short H4, short H8, short HC);
4049	void	SsSetMono			();
404A	void	SsSetMVol			(short H4, short H8);
4050	void	SsSetNext			(short H4, short H8, short HC, short H10);
4051	char	SsSetReservedVoice		(char  H4);
4052	void	SsSetStereo			();
4053	void	SsSetTempo			(short H4, short H8, short HC);
4054	void	SsSetVoiceMask			(int   H4);
4055	void	SsStart				();
4056	void	SsStart2			();
4057	char	SsUnBlockVoiceAllocation	();
4058	void	SsUtFlush			();
4059	int	SsUtGetVagAddr			(short H4, short H8);
4060	int	SsUtGetVagAddrFromTone		(short H4, short H8, short HC);
4061	int	SsUtGetVBaddrInSB		(short H4);
4062	void	SsVabClose			(short H4);
4063	short	SsVabOpenHead			(int   H4, short H8);
4064	short	SsVabTransBodyPartly		(int   H4, int   H8, short HC);
4065	short	SsVabTransCompleted		(short H4);
4066	void	SsVabTransBody			(int   H4, short H8);
4067	short	SsVoiceCheck			(int   H4, int   H8, short HC);
4068	int	SsVoKeyOff			(int   H4, int   H8);
4069	int	SsVoKeyOn			(int   H4, int   H8, uchar HC, uchar H10);
4070	short	SsVabOpenHeadSticky		(int   H4, short H8, int   HC);*/

/////////////////////////////////////////////// 5001
void StInit(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StInit()\n");
#endif

}

/////////////////////////////////////////////// 5002
void StQuit(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StQuit()\n");
#endif

}

/*
5003	void	StCalledVSync			();
5004	-*/

/////////////////////////////////////////////// 5005
short StVabOpen(int   H4, int   H8, int   HC){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StVabOpen(addr_start=0x%06X, addr_end=0x%06X, spu2addr=0x%06X)\n", H4, H8, HC);
#endif

	return 1;
}

/*5006	short	StVabOpenFakeBody		(int   H4, int   H8);*/

/////////////////////////////////////////////// 5007
void StVabOpenCompleted(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StVabOpenCompleted()\n");
#endif

}

/////////////////////////////////////////////// 5008
short StVabClose(short H4){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StVabClose(%d)\n", H4);
#endif
	return 1;
}

/*
5009	short	StBgmOpen			(short H4, int   H8);
500A	void	StSetTickMode			(short H4);
500B	short	StBgmClose			(short H4);*/

/////////////////////////////////////////////// 500C
void StSetReverbType(short core, short H8){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StSetReverbType(%s, %d)\n", core?"CORE1":"CORE0", H8);
#endif

}

/////////////////////////////////////////////// 500D
void StSetReverbDepth(short core, short H8, short HC){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StSetReverbDepth(%s, %d, %d)\n", core?"CORE1":"CORE0", H8, HC);
#endif

}

/*500E	void	StSetReverbDelaytime		(short H4, short H8);
500F	void	StSetReverbFeedback		(short H4, short H8);
5010	int	StGetSlotStatus			(short H4);*/

/////////////////////////////////////////////// 5011
void StSetSbClear(int   H4){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StSetSbClear(0x%08X)\n", H4);
#endif

}

/////////////////////////////////////////////// 5012
void StSetMasterVol(short core, short left, short right){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StSetMasterVol(%s, left=0x%X, right=0x%X)\n", core?"CORE1":"CORE0", left, right);
#endif

}

/*5013	short	StSetBgmVol			(short H4, short H8);
5014	void	StBgmPlay			(short H4);
5015	void	StBgmStop			(short H4, short H8, int   HC);
5016	void	StSetBgmTempo			(short H4, short H8);
5017	short	StGetBgmTempo			(short H4);
5018	short	StGetBgmStatus			(short H4);
5019	short	StGetBgmChStatus		(short H4, short H8, short HC);*/

/////////////////////////////////////////////// 501A
short StDmaWrite(int H4, int H8, int HC){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StDmaWrite(%d, %d, %d)\n", H4, H8, HC);
#endif

	return 1;
}

/*501B	short	StDmaRead			(int   H4, int   H8, int   HC);
5100	int	SetTimer			(&common);
5101	int	ReleaseTimer			(&common);*/

/////////////////////////////////////////////// 5200
int	StSePlay(short core, short H8){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StSePlay(%s, %d)\n", core?"CORE1":"CORE0", H8);
#endif
	return 1;
}	

/////////////////////////////////////////////// 5201
int	StSetSeVol(short core, short H8){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] StSetSeVol(%s, %d)\n", core?"CORE1":"CORE0", H8);
#endif


	return 1;
}

/*6128	int    *...				();
...		{
		 SpuGetCommonAttr(&c_attr);
		 return &c_attr;
		}
6240	int    *...				(int   H8);
...		{
		 s_attr=H8;
		 SpuGetVoiceAttr(&s_attr);
		 return &s_attr;
		}
6314	int    *...				();
...		{
		 SpuGetReverbModeParam(&r_attr);
		 return &r_attr;
		}
6418	int    *...				();
...		{
		 SpuGetAllKeysStatus(&status);
		 return &status;
		}
7128	void	SpuSetCommonAttr		(int   p);
7240	void	SpuSetVoiceAttr			(int   p);
7314	void	SpuSetReverbModeParam		(int   p);
7440	void	SpuSetKeyOnWithAttr		(int   p);
7508	void	SpuSetEnv			(int   p);
7600	void	...				(int   p);
...		{int i;
		 for (i=0; i<gMultiVoiceNum; i++)
		     SpuSetVoiceAttr(p + (i << 6));//is p an array of 64-byte structs; must check
		}
*/

/////////////////////////////////////////////// 8100
void SpuSetTransferCallback(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetTransferCallback() DUMMY\n");
#endif

}

/////////////////////////////////////////////// 8200
void SpuSetIRQCallback(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuSetIRQCallback() DUMMY\n");
#endif

}

/////////////////////////////////////////////// 8600
void SpuAutoDMASetCallback(){//DMA0CallBackProc
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] SpuAutoDMASetCallback() DUMMY\n");
#endif

}

/////////////////////////////////////////////// E621
void _Spu_start_thread(){
//  ThreadParam thp;
#ifdef RPC_LOG
	RPC_LOG("[RPC:osdsnd] _spu_start_thread()\n");
#endif

/*	thp.attr	  = 0x02000000;
	thp.entry	  = sce_spust_loop;
	thp.initPriority = 34;
	thp.stackSize	  = 0x800;
	thp.option	  = 0;
	gStThid = CreateThread(&thp);
	StartThread(gStThid, 0);*/
}

//ENTRYPOINT
void sifcall_osdsnd(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	switch (call->rpc_number) {
	case spuInit:	SpuInit();								break;
	case spuSetCore:SpuSetCore(bin[1]);						break;
	case spuSetKey:SpuSetKey(bin[1], bin[2]);				break;
	case spuSetReverbEndAddr:SpuSetReverbEndAddr(bin[1]);	break;
	case spuSetReverbModeDepth:
		SpuSetReverbModeDepth((short)bin[1], (short)bin[1]);break;
	case spuSetTransferMode:
		*bout=SpuSetTransferMode(bin[1]);					break;
	case spuSetTransferStartAddr:
		*bout=(int)SpuSetTransferStartAddr((void*)bin[1]);	break;
	case spuWrite:	*bout=SpuWrite((void*)bin[1], bin[2]);	break;
	case spuWrite0:	*bout=SpuWrite0(bin[1]);				break;
	case spuInitHot:SpuInitHot();							break;
	case spuInitMalloc:*bout=SpuInitMalloc(bin[1]);			break;
	case spuMalloc:	*bout=SpuMalloc(bin[1]);				break;
	case spuAutoDMAWrite:
		*bout=SpuAutoDMAWrite(bin[1], bin[2], bin[3]);		break;
	case spuAutoDMAStop:SpuAutoDMAStop();					break;
	case spuAutoDMAGetStatus:*bout=SpuAutoDMAGetStatus();	break;
	case stInit:	StInit();								break;
	case stQuit:	StQuit();								break;
	case stVabOpen:	*bout=StVabOpen(bin[1], bin[2], bin[3]);break;
	case stVabOpenCompleted:StVabOpenCompleted();			break;
	case stVabClose:*bout=StVabClose((short)bin[1]);		break;
	case stSetReverbType:
		StSetReverbType((short)bin[1], (short)bin[2]);		break;
	case stSetReverbDepth:	StSetReverbDepth((short)bin[1],
							  (short)bin[2], (short)bin[3]);break;
	case stSetSbClear:StSetSbClear(bin[1]);					break;
	case stSetMasterVol:StSetMasterVol((short)bin[1],
							  (short)bin[2], (short)bin[3]);break;
	case stDmaWrite:
		StDmaWrite(bin[1], bin[2], bin[3]);					break;
	case stSePlay:
		*bout=StSePlay((short)bin[1], (short)bin[2]);		break; 
	case stSetSeVol:
		*bout=StSetSeVol((short)bin[1], (short)bin[2]);		break;
	case spuSetTransferCallback:SpuSetTransferCallback();	break;
	case spuSetIRQCallback:		SpuSetIRQCallback();		break;
	case spuAutoDMASetCallback:	SpuAutoDMASetCallback();	break;
	case _spu_start_thread:		_Spu_start_thread();		break;
	default:
#ifdef RPC_LOG
		RPC_LOG("[RPC:osdsnd] <%04X> function is not implemented\n", call->rpc_number);
#endif
		//*bout=-1;	//general fail
		break;
	}
}
