/*
 *  Original code from sjdata.irx by Sjeep (C) 2002
 *  Modified by Florin for PCSX2 emu
 */

#ifndef	_SJDATA_H
#define	_SJDATA_H

#include "Common.h"

extern char datafile_name[256];

/*	SjDrive Datafile header info:
	-----------------------------

	Offset | Length | Description
	------ |--------|----------------------------------------------------
	 00    |   04   | Contains the string "SJDF" to identify the file
	 04    |   04   | Amount of entries in the datafile
	 08    |   XX   | Start of datafile index table

	The datafile index is set out as follows:
	-----------------------------------------

	Each entry is set out like this:

	Offset | Length | Description
	------ |--------|----------------------------------------------------
	 00    |  56    | File name
	 56    |  4     | Length of file, in bytes.
	 60    |  4     | Offset of file data, from start of datafile.

	The number of entries is specified by the number at offset 04 in the datafile header.
	Files start getting placed directly after the last entry in the index table.
*/

void SjDATA_init();
int  SjDATA_lseek(int, int, int);
int  SjDATA_open(char*, int);
int  SjDATA_read(int, char*, int);
int  SjDATA_write(int, char*, int);
int  SjDATA_close(int);

#endif
