/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "PS2Edefs.h"

#include "bios_syscalls.h"

#define PAD_RPCCMD_OPEN         0x80000100
#define PAD_RPCCMD_INFO_ACT		0x80000102
#define PAD_RPCCMD_INFO_COMB	0x80000103
#define PAD_RPCCMD_INFO_MOD		0x80000104
#define PAD_RPCCMD_SET_MMODE    0x80000105
#define PAD_RPCCMD_SET_ACTDIR   0x80000106
#define PAD_RPCCMD_SET_ACTALIGN 0x80000107
#define PAD_RPCCMD_GET_BTNMASK  0x80000108
#define PAD_RPCCMD_SET_BTNINFO  0x80000109
#define PAD_RPCCMD_SET_VREF     0x8000010a
#define PAD_RPCCMD_GET_PORTMAX  0x8000010b
#define PAD_RPCCMD_GET_SLOTMAX  0x8000010c
#define PAD_RPCCMD_CLOSE        0x8000010d
#define PAD_RPCCMD_END          0x8000010e

#define PAD_RPCCMD_INIT         0x8000010F	//???
#define PAD_RPCCMD_INIT2        0x00000100	//???


#define InfoModeCurID		(1)
#define InfoModeCurExID		(2)
#define InfoModeCurExOffs	(3)
#define InfoModeIdTable		(4)


#define	PAD_INFO_TYPE_NEGI_COM 		2
#define	PAD_INFO_TYPE_KONAMI_GUN 	3
#define	PAD_INFO_TYPE_STANDARD  	4
#define	PAD_INFO_TYPE_JOY_STICK 	5
#define	PAD_INFO_TYPE_NAMCO_GUN 	6
#define	PAD_INFO_TYPE_ANALOG  		7
#define	PAD_INFO_TYPE_TSURI_CON 	0x100:
#define	PAD_INFO_TYPE_JOG_CON 		0x300:



/*
At Adress fBinaryInAddr, note: value(position)
: 80000100(0) 00000000(1) 00000000(2) 00000000(3)
: 003309c0(4) 00000000(5) 00000000(6) 00000000(7)



*/

void RPC_8000010f_PadMan1( _u32 fRPCcommand, _u64 fBinaryInAddr, _u64 fBinaryOutAddr ) {
	char temp_string[100];
	char * tempString;

	
	_u32 * RPC_Pad_Command;
	_u32 * RPC_Pad_Return;


	int port;

	switch ( fRPCcommand ) {
		
		case 0x1:
			RPC_Pad_Command = (  _u32 * ) &MipsMemory [   fBinaryInAddr  & 0x01FFFFFF ];
	



			

			switch( *RPC_Pad_Command ) {

				case PAD_RPCCMD_INIT2:

#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_PAD1][PadCommand] INIT2");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif

					RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
					*(RPC_Pad_Return + 3) = 1;

				break;



				case PAD_RPCCMD_OPEN:

#ifdef SYSCALL_LOG
				SYSCALL_LOG("[RPC_PAD1][PadCommand] OPEN");
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//				SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif


					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip
					: 80000100(0) 00000000(1) 00000000(2) 00000000(3)
					: 003309c0(4) 00000000(5) 00000000(6) 00000000(7)

						0: command
						1: port
						2: slot
						3: return 0:failed  1:OK
						4: addr of Data
				
						Disasm Turnip at address: 0x002060D0					


					*/
						
					port = *(RPC_Pad_Command + 1);
					RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];

					Ps2Bios.PadData[port][0] = (struct _Pad_Data * ) &MipsMemory [   ((_u32)*(RPC_Pad_Command + 4)) & 0x01FFFFFF ];
					Ps2Bios.PadData[port][1] = (struct _Pad_Data * ) &MipsMemory [   ((_u32)*(RPC_Pad_Command + 4 + sizeof(struct _Pad_Data))) & 0x01FFFFFF ];


					Ps2Bios.PadData[port][1]->frame = 0;
					Ps2Bios.PadData[port][0]->frame = 0;
			
					Ps2Bios.PadData[port][0]->state 		= PAD_STATE_STABLE;
					Ps2Bios.PadData[port][0]->reqState 		= PAD_RSTAT_COMPLETE;
					Ps2Bios.PadData[port][0]->length 		= sizeof(struct _padButtonStatus);

					
	
		
					Ps2Bios.PadState[port] = (struct _padButtonStatus*)Ps2Bios.PadData[port][0]->data;
					Ps2Bios.PadState[port]->btns[0] = 0xFF;
					Ps2Bios.PadState[port]->btns[1] = 0xFF;

					*(RPC_Pad_Return + 3) = 1;
					

				break;

				case PAD_RPCCMD_SET_MMODE:

#ifdef SYSCALL_LOG
					SYSCALL_LOG("[RPC_PAD1][PadCommand] SET_MMODE");
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif

					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip
       				|Header: 80000105 00000000 00000000 00000001
        			|Header: 00000003 00000000 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000
	
						0: command
						1: port
						2: slot
						3: Offset in controller mode ID table containing the switched controller mode
						4: Lock/Unlock analog switch 0, 1: keep current lock/unlock status 2: Unlock 3: Lock
						5: return Value

						Disasm Turnip at address: 0x002067C0


					*/
					port = *(RPC_Pad_Command + 1);
					RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
			
					/*
						if the Port is other than 0 , I can't set the mode
					*/
					
					switch (  port ) {
						case 0 : *(RPC_Pad_Return + 5 ) = 1; break;

						default: *(RPC_Pad_Return + 5 ) = 0; break ;


					}
					
					//*(RPC_Pad_Return + 5 ) = 1;
					 //	1 : Request Received
					//  0 : Request Not rceived
			

				break;

			case PAD_RPCCMD_GET_PORTMAX:
#ifdef SYSCALL_LOG
					SYSCALL_LOG("[RPC_PAD1][PadCommand] GET_PORTMAX");
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif
				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 3 ) = 2;


			break;

			case PAD_RPCCMD_GET_SLOTMAX:
#ifdef SYSCALL_LOG
					SYSCALL_LOG("[RPC_PAD1][PadCommand] GET_SLOTMAX");
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif
				/*
					Disasm Turnip at address: 0x00206650
					0: command
					1: slot
					2: ?? not used
					3: return 

				*/
						
				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 3 ) = 1;


			break;

			case PAD_RPCCMD_GET_BTNMASK:
#ifdef SYSCALL_LOG
					SYSCALL_LOG("[RPC_PAD1][PadCommand] GET_BTNMASK");
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif
					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip

        			|Header: 80000108 00000000 00000000 00000001
        			|Header: 00000003 00000004 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000

					Disasm Turnip at address: 0x002069E8
					0: command
					1: port
					2: slot
					3: return 
					
					return Checked at 0x002068C0	

					*/



				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 3 ) = 0;			// No Pressure-sensitive functions supported
				//*(RPC_Pad_Return + 3 ) = 0x3FFFF;		//Pressure-sensitive functions supported


			break;

			case PAD_RPCCMD_SET_BTNINFO:
				//bout[12/4] = 1;
#ifdef SYSCALL_LOG
					SYSCALL_LOG("[RPC_PAD1][PadCommand] SET_BTNINFO");
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif

					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip

       				|Header: 80000109 00000000 00000000 00000fff
        			|Header: 00000003 00000004 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000
					
					Disasm Turnip at address: 0x00206AA0
					0: command
					1: port
					2: slot
					3: ???
					4: return 


  					*/



				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 4 ) = 1;		//Must not be 1


			break;



			case PAD_RPCCMD_INFO_MOD :
#ifdef SYSCALL_LOG
					SYSCALL_LOG("[RPC_PAD1][PadCommand] INFO_MOD");
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));
//					SYSCALL_LOG("       |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));
#endif
			/*
     			|_PadMan1_RPCCommand:PAD_RPCCMD_INFO_MOD
        			|Header: 80000104 00000000 00000000 00000001
        			|Header: 00000000 00000000 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000					
				
					0: command
					1: port
					2: slot
					3: term : item to be checked
					4: offset 
					5:return
			*/


				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];

				switch( *(RPC_Pad_Command+3) ) {
			
					case InfoModeCurID :
						//Return the PAD TYPE : MUST NOT BE ZERO
						 *(RPC_Pad_Return + 5 ) = PAD_INFO_TYPE_STANDARD;
						
								
					break;
					
					case InfoModeCurExID:
						//Return the PAD TYPE : MUST NOT BE ZERO
						 *(RPC_Pad_Return + 5 ) = PAD_INFO_TYPE_STANDARD;
						
						
					break;
				
					default	: *(RPC_Pad_Return + 5 ) = PAD_INFO_TYPE_STANDARD;
					break;
				}



			break;

			default:
#ifdef EMU_LOG
				EMU_LOG("[RPC_PAD1][PadCommand] Unknow: 0x%8.8lx",*RPC_Pad_Command);
#endif
			break;
	
			}

		break;
	
		default:
#ifdef EMU_LOG
			EMU_LOG("[RPC_PAD1] command Unknow: 0x%8.8lx",fRPCcommand);
#endif
		break;
	
	}


}

