/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "r5900_main.h"
 
#include "bios_syscalls.h"
#include "bios_syscalls_table.h"
 
#include "PS2Edefs.h"

#include "Sif.h"

/* I must declare a function to avoid this kind of include */
#include "DmaC.h"

/* must create function to avoid this kind of declaration */
#include "IntrC.h"


#include "GS.h"



/**********************************************************************************************************
									ALARM
***********************************************************************************************************/


/* _SetAlarm	ENTRY_24	800022d8 */ 
void SYSCALL__SetAlarm( ) { 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]_SetAlarm : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
} 

/* _ReleaseAlarm	ENTRY_25	80002570 */
void SYSCALL__ReleaseAlarm( ) { 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]_ReleaseAlarm : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
} 

void SYSCALL__iReleaseAlarm( ) 					{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]_iReleaseAlarm : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}     


void SYSCALL__iSetAlarm( ) 						{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]_iSetAlarm : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}     


