
/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "r5900_main.h"
 
#include "bios_syscalls.h"
#include "bios_syscalls_table.h"
 
#include "PS2Edefs.h"

#include "Sif.h"

/* I must declare a function to avoid this kind of include */
#include "DmaC.h"

/* must create function to avoid this kind of declaration */
#include "IntrC.h"


#include "GS.h"





/**********************************************************************************************************
									EVENT 
***********************************************************************************************************/
/*
// --- EventFlag --- 
struct EventFlagParam {
    u_int	attr;			
    u_int	option;			
    u_int	initPattern;	
};

struct EventFlagInfo {
    u_int	attr;		
    u_int	option;		
    u_int	initPattern;	
    u_int	currentPattern;	
    int		numWaitThreads;	
    int		reserved1;
    int		reserved2;
};

// EventFlagParam->attr, EventFlagInfo->attr 
#define EA_SINGLE	AT_SINGLE
#define EA_MULTI	AT_MULTI

// waitmode *
#define EW_AND		0
#define EW_OR		1
#define EW_CLEAR	0x10

extern int CreateEventFlag( struct EventFlagParam *param );
extern int DeleteEventFlag( int evfid );
extern int SetEventFlag( int evfid, u_long bitpattern );
extern int iSetEventFlag( int evfid, u_long bitpattern );
extern int ClearEventFlag( int evfid, u_long bitpattern );
extern int iClearEventFlag( int evfid, u_long bitpattern );
extern int WaitEventFlag( int evfid, u_long bitpattern, int waitmode,
			   u_long *resultpat );
extern int PollEventFlag( int evfid, u_long bitpattern, int waitmode,
		   u_long *resultpat );
extern int ReferEventFlagStatus( int evfid, struct EventFlagInfo *info );
extern int iReferEventFlagStatus( int evfid, struct EventFlagInfo *info );

*/


void SYSCALL_RFU080_CreateEventFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]CreateEventFlag : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU081_DeleteEventFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]DeleteEventFlag : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU082_SetEventFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]SetEventFlag : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1;  
}   



void SYSCALL_RFU083_iSetEventFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]iSetEventFlag : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU084_ClearEventFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]ClearEventFlag : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU085_iClearEventFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]iClearEventFlag : NI",(long)MipsCpu.PC );
#endif	
	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU086_WaitEvnetFlag( ) 			{ 
	char temp_string[256];

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]WaitEvnetFlag : NI",(long)MipsCpu.PC );
#endif	


/*
    	sprintf(temp_string,"|A0:%8.8lx A1:%8.8lx A2:%8.8lx A3:%8.8lx  \n", MipsCpu.GPR[CPU_REG_A0],
		MipsCpu.GPR[CPU_REG_A1],MipsCpu.GPR[CPU_REG_A2],MipsCpu.GPR[CPU_REG_A3] );PrintToEmuOutput (  temp_string );
*/


	
	
	MipsCpu.GPR[CPU_REG_V0].lo = 0;

	MipsCpu.PC = MipsCpu.PC + 4;

//	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU087_PollEvnetFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]PollEvnetFlag : NI",(long)MipsCpu.PC );
#endif
	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU088_iPollEvnetFlag( ) 			{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]iPollEvnetFlag : NI",(long)MipsCpu.PC );
#endif
	MipsCpu.halt = 1; 
}   




void SYSCALL_RFU089_ReferEventFlagStatus( ) 	{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]ReferEventFlagStatus : NI",(long)MipsCpu.PC );
#endif
	MipsCpu.halt = 1; 
}   




void SYSCALL_RFU090_iReferEventFlagStatus( )	{ 
char temp_string[256];
	_u8		SystemCallNumber;
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]iReferEventFlagStatus : NI",(long)MipsCpu.PC );
#endif
/*
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();		
		sprintf(temp_string,"|A0= 0x%8.8llx\n",MipsCpu.GPR[CPU_REG_A0].lo);
		sprintf(temp_string,"%s|A1= 0x%8.8llx\n",temp_string,MipsCpu.GPR[CPU_REG_A1].lo);
		sprintf(temp_string,"%s|A2= 0x%8.8llx\n",temp_string,MipsCpu.GPR[CPU_REG_A2].lo);

		PrintToBIOSOutput (  temp_string );
	}
*/

	
 	SystemCallNumber = MipsCpu.GPR[CPU_REG_A0].lo & 0xFF;
 	if ((signed char)SystemCallNumber < 0) SystemCallNumber = (- SystemCallNumber ) & 0xFF ;

/*
	if ( debug_thread == 1 ) {
			sprintf(temp_string,"(%d)[SYSCALL] Exec Syscall n %d \n",Ps2Bios.PS2_Sched.RunningIDThread,SystemCallNumber);PrintToEmuOutput (  temp_string );
	}
*/

	MipsCpu.PC = MipsCpu.PC + 4;
	//MipsCpu.halt = 1;
}     



