/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "r5900_main.h"
 
#include "bios_syscalls.h"
#include "bios_syscalls_table.h"
 
#include "PS2Edefs.h"

#include "Sif.h"

/* I must declare a function to avoid this kind of include */
#include "DmaC.h"

/* must create function to avoid this kind of declaration */
#include "IntrC.h"


#include "GS.h"


/**********************************************************************************************************
								GS									
***********************************************************************************************************/


/*
SetGsCrt 02h
8000a060
*/
u64 GsCrtVal = 0x90b27d0000000000;

void _SetGsCrt2() {
	_u32 tmp;
	_u128 temp128	;
	
 	

	MipsMemoryRead( &temp128, DATA_W,0x8002f344, 0);
	
	if (temp128.lo == 0x40 || temp128.lo == 0x60 || temp128.lo == 0x61) {

		temp128.lo = 0;
		MipsMemoryWrite( temp128, DATA_B,0xbf803218, 0);	

		temp128.lo = 0;
		MipsMemoryWrite( temp128, DATA_B,0xbf803218, 2);	
		
 		return;
	}

  	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_HW,0xbf801470, 0);	
	MipsMemoryWrite( temp128, DATA_HW,0xbf801472, 0);

	temp128.lo = 1;
 	MipsMemoryWrite( temp128, DATA_HW,0xbf801472, 0);

}

void SYSCALL_SetGsCrt( ) { 
	char temp_string[256];	
	_u32 arg0, arg1, arg2;
	_u64 val, val2;
	_u64 tmp;
	
	_u128	temp128;

    arg0 = MipsCpu.GPR[CPU_REG_A0].lo & 0xFFFF;
	arg1 = MipsCpu.GPR[CPU_REG_A1].lo & 0xFFFF;
	arg2 = MipsCpu.GPR[CPU_REG_A2].lo & 0xFFFF;

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]SetGsCrt  arg0: 0x%4.4lx, arg1: 0x%4.4lx, arg2: 0x%4.4lx,",(long)MipsCpu.PC,
		arg0, arg1, arg2 );
#endif	


/*
	if (arg1 == 0) {
		SysPrintf("unhandled arg1 == 0 on SetGsCrt!!\n");
	}
*/
 

  	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_W,0x8002f344, 0);	

/*
	if (arg1 != 2) {
		SysPrintf("unhandled case on SetGsCrt!!\n");
	}
*/

	if (arg0 != 0) {
		val = 0x740834504;
		val2 = 0x740814504;

		tmp = (s32)GsCrtVal & 0x1;
		tmp<<= 25;
		val|= tmp;
		val2|= tmp;

		(*GSwrite64)(0x12000010, val);
		(*GSwrite64)(0x12000040, 0x7F5B61F06F040);
		(*GSwrite64)(0x12000050, 0x33A4D8);
		(*GSwrite64)(0x12000060, 0xC7800601A01801);

		tmp = (_u64)arg2 << 48;
		tmp>>= 15;
		tmp|= 1;
		(*GSwrite64)(0x12000020, tmp);
		(*GSwrite64)(0x12000030, 8);
		(*GSwrite64)(0x12000010, val2);
	} else {
		val = 0x740834504;
		val2 = 0x740814504;

		tmp = (GsCrtVal >> 1) & 0x1;
		tmp<<= 36;
		val|= tmp;
		val2|= tmp;

		tmp = (_s32)GsCrtVal & 0x1;
		tmp<<= 25;
		val|= tmp;
		val2|= tmp;

		(*GSwrite64)(0x12000010, val);
		(*GSwrite64)(0x12000040, 0x7F5B61F06F040);
		(*GSwrite64)(0x12000050, 0x33A4D8);
		(*GSwrite64)(0x12000060, 0xC7800601A01802);
		(*GSwrite64)(0x12000020, 0);
		(*GSwrite64)(0x12000030, 8);
		(*GSwrite64)(0x12000010, val2);
	}
	//_SetGsCrt2(); 

	MipsCpu.PC = 	MipsCpu.PC + 4;	
} 












/*

*/
void SYSCALL_GsGetIMR( ) 						{ 
	_u128	temp128;

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]GsGetIMR ",(long)MipsCpu.PC );
#endif	
 
	
	MipsMemoryRead ( &temp128 , DATA_DW ,  GS_IMR  ,0 ) ;
	MipsCpu.GPR[CPU_REG_V0].lo = temp128.lo;

	MipsCpu.PC = MipsCpu.PC + 4;
} 

/*
GsPutIMR
Write A0 to 0x12001010
V0 = A0
*/
void SYSCALL_GsPutIMR( ) 						{ 
	char temp_string[256];

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]GsPutIMR IMR : 0x%8.8lx ",(long)MipsCpu.PC, MipsCpu.GPR[CPU_REG_A0].lo );
#endif	

	MipsCpu.GPR[CPU_REG_V0].lo = (_u64)MipsCpu.GPR[CPU_REG_A0].lo;
	MipsMemoryWrite ( MipsCpu.GPR[CPU_REG_A0] , DATA_DW ,  GS_IMR  ,0 ) ;			// (12001010 : GS_IMR) = A0
	
	INCREMENT_PC();
} 



void SYSCALL_GetGsHParam( ) 					{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]GetGsHParam : NI ",(long)MipsCpu.PC );
#endif	

	MipsCpu.halt = 1; 
}  



void SYSCALL_GetGsVParam( ) 					{ 

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]GetGsVParam : NI ",(long)MipsCpu.PC );
#endif	


	MipsCpu.halt = 1; 

}   



void SYSCALL_SetGsHParam( ) 					{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]SetGsHParam : NI ",(long)MipsCpu.PC );
#endif	

	MipsCpu.halt = 1; 
}   



void SYSCALL_SetGsVParam( ) 					{ 

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]SetGsVParam : NI ",(long)MipsCpu.PC );
#endif	
	
	//MipsCpu.halt = 1; 
	INCREMENT_PC();

}   


/*
GsPutIMR	ENTRY_113	80000d40

12001010	IMR			Interrupt mask
*/
void SYSCALL_iGsPutIMR( ) 						{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]iGsPutIMR : 0x%8.8lx ",(long)MipsCpu.PC, MipsCpu.GPR[CPU_REG_A0].lo );
#endif	

	SYSCALL_GsPutIMR();
} 


/*
GsGetIMR	ENTRY_112	80000d00



*/
void SYSCALL_iGsGetIMR( ) 						{

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]iGsGetIMR ",(long)MipsCpu.PC );
#endif	

	SYSCALL_GsGetIMR( ) ;
} 



