/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>




#include "nSX2.h"
#include "PS2Edefs.h"

#include"_Debuger/debuger.h"

#include "main.h"

#include "Sif.h"
#include "pluggins_main.h"


#define LoadGSsym1(dest, name) \
	LoadSym(GS##dest, _GS##dest, name, 1);

#define LoadGSsym0(dest, name) \
	LoadSym(GS##dest, _GS##dest, name, 0); \
	if (GS##dest == NULL) GS##dest = (_GS##dest) GS_##dest;

void *GSplugin = NULL;



_u8 LoadGsPluggin( char * filename ) {

	void *drv;
	if (GSplugin != NULL) { FreeLibrary((HMODULE)GSplugin); }  // * Free plugin
	
	GSplugin = LoadLibrary(filename);
	if (GSplugin == NULL) { ShowMessage ("Could Not Load GS Plugin %s\n", filename); return 1; }
	
    sprintf(GSPluginToUse,filename);
	
    drv = GSplugin;

	LoadGSsym1(init,         "GSinit");
	LoadGSsym1(shutdown,     "GSshutdown");
	LoadGSsym1(open,         "GSopen");
	LoadGSsym1(close,        "GSclose");
	LoadGSsym1(gifTransfer,  "GSgifTransfer");
	LoadGSsym1(gifTransfer2, "GSgifTransfer2");
	LoadGSsym1(write32,      "GSwrite32");
	LoadGSsym1(write64,      "GSwrite64");
	LoadGSsym1(read32,       "GSread32");
	LoadGSsym1(read64,       "GSread64");
	LoadGSsym1(vsync,        "GSvsync");

	LoadGSsym1(keyEvent,     "GSkeyEvent");
	LoadGSsym1(makeSnapshot, "GSmakeSnapshot");
	LoadGSsym1(configure,    "GSconfigure");
	LoadGSsym1(about,        "GSabout");
	LoadGSsym1(test,         "GStest");

	return 0; 
}


