/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"

#include "r5900_debug_regs.h"
 
#include "r5900_main.h"

#include "r5900_core.h"
#include "r5900_core_table.h"

#include "r5900_cop0.h"
#include "r5900_cop0_table.h"

#include "r5900_cop1.h"
#include "r5900_cop1_table.h"

#include "r5900_mmi.h"
#include "r5900_mmi_table.h"

#include "PS2Edefs.h"
#include "_Debuger/debuger.h"



/* Test if a value is SignExtended : NEED TO BE CHECKED*/
_u8 IsSignExtended( _u64 fval ) {

    _u64    temp;
/*   
    temp = fval & 0xFFFFFFFF00000000;
    if (    ( temp == 0 ) || ( temp == 0xFFFFFFFF00000000 ) ) return TRUE;
    else return FALSE;        
*/
	return TRUE;
   
}

/* Test if a value is Overflow : NEED TO BE CHECKED*/
_u8 IsNot32bitIntegerOverflow ( _u64  fval) {

    _u32    temp;

/*	
	if ( (_u64)fval < 0xFFFFFFFF ) return TRUE;
	else {
		if ( (_u64)fval & 0xFFFFFFFF00000000 ) return TRUE;
		else return FALSE;
		}
*/
	return TRUE;

}


/*
Not sure
*/
_u8 IsNot64bitIntegerOverflow ( _u64  fval) {
/*
    _u64    temp;
   
    temp = ( (~fval) + 1 );

    if ( temp == 0 ) return FALSE;
    else return TRUE;
*/
	return TRUE;
        
}

/*
Not Implemented function
*/
void    NI(){	PrintDebugOpcode();MipsCpu.halt = 1;}


/*
N OPeration function
*/
void    NOP() 		{ 	INCREMENT_PC(); }
  

/*****************************************************************************************************************
									CPU INSTRUCTION SET
*****************************************************************************************************************/

void 	SPECIAL()	{	special_opc[(_OPCODE_  & 0x3F)]();	}

void 	REGIMM()	{	regimm_opc[(_OPCODE_  & 0x1F0000)>>16]();		}


void   ADD     () {
	_u64 temp;

	MipsCpu.GPR[CURRENT_RD].lo =(_s64)((_s32)MipsCpu.GPR[CURRENT_RS].lo + (_s32)MipsCpu.GPR[CURRENT_RT].lo);
	
	INCREMENT_PC();
}



void    ADDI   () {
	_u64 temp;

	MipsCpu.GPR[CURRENT_RT].lo = (_s64)( (_s32)MipsCpu.GPR[CURRENT_RS].lo + (_s32)((_s16)CURRENT_IMM) );

	INCREMENT_PC();
}



void    ADDIU () {

 	MipsCpu.GPR[CURRENT_RT].lo = (_u64)((_s32)MipsCpu.GPR[CURRENT_RS].lo + (_s32)((_s16)CURRENT_IMM));
    
    INCREMENT_PC();
}





void   ADDU    () {

	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s32)MipsCpu.GPR[CURRENT_RS].lo + (_s32)MipsCpu.GPR[CURRENT_RT].lo);

	INCREMENT_PC();
}




void   AND () {
	
	MipsCpu.GPR[CURRENT_RD].lo =(_u64)( (_u64)MipsCpu.GPR[CURRENT_RS].lo & (_u64)MipsCpu.GPR[CURRENT_RT].lo);
	
	INCREMENT_PC();
}




void    ANDI() {
	
	MipsCpu.GPR[CURRENT_RT].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RS].lo & (_u64)CURRENT_IMM );
	
	INCREMENT_PC();
}




void     BEQ () {
	_u64	target_branch;
	
	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo == (_s64)MipsCpu.GPR[CURRENT_RT].lo ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );
	
		CalculTargetBranch;	
	
        INCREMENT_PC();
		MipsUpdateCpu();
		
        MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
} 



void     BEQL() {
	_u64	target_branch;

	
	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo == (_s64)MipsCpu.GPR[CURRENT_RT].lo ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8;
}



void      BGEZ() {
	_u64	target_branch;


	if ( (_s64)(MipsCpu.GPR[CURRENT_RS].lo) >= 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
}


void      BGEZAL () {
	_u64	target_branch;


	MipsCpu.GPR[ CPU_REG_RA ].lo =  MipsCpu.PC + 8;

	if ( (_s64)(MipsCpu.GPR[CURRENT_RS].lo) >= 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
}



void      BGEZALL() {
	_u64	target_branch;


	MipsCpu.GPR[ CPU_REG_RA ].lo =  MipsCpu.PC + 8;

	if ( (_s64)(MipsCpu.GPR[CURRENT_RS].lo) >= 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8; 

}

void      BGEZL  () {		
	_u64	target_branch;
	

	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo >= 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8;
}



void     BGTZ () {
	_u64	target_branch;
	char	BGTZ_dbg[100];


	if ( (_s64)( MipsCpu.GPR[CURRENT_RS].lo ) > 0 ) {
		


		CalculTargetBranch;


		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;

		if ( debug_op == 1 ) PrintToOpcodeOutput ( BGTZ_dbg );

	}
	else INCREMENT_PC(); 
}



void    BGTZL() {		
	_u64	target_branch;


	if ( (_s64)( MipsCpu.GPR[CURRENT_RS].lo ) > 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8; 
}



void     BLEZ () {
	_u64	target_branch;

	
	if ( (_s64)(MipsCpu.GPR[CURRENT_RS].lo) <= 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
}



void    BLEZL() {		
	_u64	target_branch;

	
	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo <= 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8;
}



void	BLTZ() {
	_u64	target_branch;

	
	if ((_s64)( MipsCpu.GPR[CURRENT_RS].lo) < 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
}


void      BLTZAL () {
	_u64	target_branch;
	

	MipsCpu.GPR[ CPU_REG_RA ].lo =  MipsCpu.PC + 8;
	
	if ((_s64)( MipsCpu.GPR[CURRENT_RS].lo) < 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
	
}


void      BLTZALL() {
	_u64	target_branch;
	

	MipsCpu.GPR[ CPU_REG_RA ].lo =  MipsCpu.PC + 8;
	
	if ((_s64)( MipsCpu.GPR[CURRENT_RS].lo) < 0 ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8; 
	
}




void      BLTZL  () {		
	_u64	target_branch;


	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo < 0 ) {

		CalculTargetBranch;

		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );
		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8;
}


void     BNE () {
	_u64	target_branch;


	
	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo != (_s64)MipsCpu.GPR[CURRENT_RT].lo ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else INCREMENT_PC();
}



void     BNEL() {
	_u64	target_branch;


	
	if ( (_s64)MipsCpu.GPR[CURRENT_RS].lo != (_s64)MipsCpu.GPR[CURRENT_RT].lo ) {
		if ( debug_op == 1 ) PrintToOpcodeOutput ( debugTempText );

		CalculTargetBranch;

		INCREMENT_PC();
		MipsUpdateCpu();
		MipsCpu.PC = target_branch;
	}
	else MipsCpu.PC = MipsCpu.PC + 8;
}



void	BREAK()	{	

	MipsCpu.CPR0[13][0] = 0x24;
    MipsCpu.CPR0[14][0] = MipsCpu.PC;


	MipsCpu.halt = 1;
	(* DBG_SendBreak)( );


	INCREMENT_PC();
}



void	DADD()	{	

	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s64)MipsCpu.GPR[CURRENT_RS].lo + (_s64)MipsCpu.GPR[CURRENT_RT].lo);

	INCREMENT_PC();

}



void	DADDI()	{

	MipsCpu.GPR[CURRENT_RT].lo = (_u64)((_s64)MipsCpu.GPR[CURRENT_RS].lo + (_s64)((_s16)CURRENT_IMM));

	INCREMENT_PC();

}




void    DADDIU    () {


	MipsCpu.GPR[CURRENT_RT].lo = (_u64)((_s64)MipsCpu.GPR[CURRENT_RS].lo + (_s64)((_s16)CURRENT_IMM));

	INCREMENT_PC();
}



void   DADDU  () {

	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s64)MipsCpu.GPR[CURRENT_RS].lo + (_s64)MipsCpu.GPR[CURRENT_RT].lo);

	INCREMENT_PC();
}



void   DIV  () {		

	if ( (_s32)MipsCpu.GPR[CURRENT_RT].lo != 0 ) {

       MipsCpu.GPR[CPU_REG_LO].lo = (_s64)((_s32)MipsCpu.GPR[CURRENT_RS].lo / (_s32)MipsCpu.GPR[CURRENT_RT].lo);
       MipsCpu.GPR[CPU_REG_HI].lo = (_s64)((_s32)MipsCpu.GPR[CURRENT_RS].lo % (_s32)MipsCpu.GPR[CURRENT_RT].lo);

	}
	INCREMENT_PC();
}
 


void   DIVU () {

	if ( (_u32)MipsCpu.GPR[CURRENT_RT].lo != 0 ) {

       MipsCpu.GPR[CPU_REG_LO].lo = (_s64) ((_u32)MipsCpu.GPR[CURRENT_RS].lo / (_u32)MipsCpu.GPR[CURRENT_RT].lo);
       MipsCpu.GPR[CPU_REG_HI].lo = (_s64) ((_u32)MipsCpu.GPR[CURRENT_RS].lo % (_u32)MipsCpu.GPR[CURRENT_RT].lo);

	}
	
	INCREMENT_PC();
}




void   DSLL     () {

	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RT].lo << CURRENT_SA ) ;
	
	INCREMENT_PC();
}




void   DSLL32  () {
	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RT].lo <<  (CURRENT_SA + 32 )) ;

	INCREMENT_PC();
}



void   DSLLV () {	

	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RT].lo <<  ( (_u32)MipsCpu.GPR[CURRENT_RS].lo & 0x3F));
 
 	INCREMENT_PC();
}





void   DSRA  () {
	_u64 temp;
	_u8 boucle;
	

	MipsCpu.GPR[CURRENT_RD].lo =  (_s64)((_s64)MipsCpu.GPR[CURRENT_RT].lo >>  CURRENT_SA);	
      		
	INCREMENT_PC();
}




void   DSRA32() {
	_u8	 boucle;	
	_u64 temp;


	MipsCpu.GPR[CURRENT_RD].lo =  (_s64)((_s64)MipsCpu.GPR[CURRENT_RT].lo >>  (CURRENT_SA+32));

	INCREMENT_PC();
}




void   DSRAV () {
 
 MipsCpu.GPR[CURRENT_RD].lo = (_s64)((_s64)MipsCpu.GPR[CURRENT_RT].lo >> ((_u32)MipsCpu.GPR[CURRENT_RS].lo & 0x3f) ) ;
 
 INCREMENT_PC();

}


void   DSRL  () {
	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RT].lo >> CURRENT_SA ) ;
	
	INCREMENT_PC();
}





void   DSRL32   () {

	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RT].lo >>  (CURRENT_SA+32) )  ;
	
	INCREMENT_PC();
}


void   DSRLV () {	
		
	MipsCpu.GPR[CURRENT_RD].lo =  (_u64)((_u64)MipsCpu.GPR[CURRENT_RT].lo   >>  ( (_u32)MipsCpu.GPR[CURRENT_RS].lo & 0x3F));	
		
	INCREMENT_PC();
}



void   DSUB  () {	
	
	MipsCpu.GPR[CURRENT_RD].lo = (_s64)((_s64)MipsCpu.GPR[CURRENT_RS].lo - (_s64)MipsCpu.GPR[CURRENT_RT].lo);
	
	INCREMENT_PC();



}


void   DSUBU() {
	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s64)MipsCpu.GPR[CURRENT_RS].lo - (_s64)MipsCpu.GPR[CURRENT_RT].lo);
	
	INCREMENT_PC();
}





void J() {
	_u64 	target_branch;
	
	target_branch = ((_u32)MipsCpu.PC & (_u32)0xF0000000) |(  CURRENT_INSTR_INDEX  << 2 );

	
	INCREMENT_PC();
	MipsUpdateCpu();
	
	MipsCpu.PC =  target_branch;
}



void     JAL  () {
	_u64 	target_branch;
	
	MipsCpu.GPR[ CPU_REG_RA ].lo =  MipsCpu.PC + 8;
	target_branch = ((_u32)MipsCpu.PC & (_u32)0xF0000000) |(  CURRENT_INSTR_INDEX  << 2 );

	
	INCREMENT_PC();
	MipsUpdateCpu();
	
	MipsCpu.PC =  target_branch;
}




void   JALR () {
	_u64	branch_target;
	
	branch_target = MipsCpu.GPR[CURRENT_RS].lo;
	MipsCpu.GPR[CURRENT_RD].lo = MipsCpu.PC + 8;


	
	INCREMENT_PC();
	MipsUpdateCpu();
	
	MipsCpu.PC =  branch_target;
}



void   JR   () {
	_u64	branch_target;
	
	branch_target = MipsCpu.GPR[CURRENT_RS].lo;
	
	INCREMENT_PC();
	MipsUpdateCpu();
	
	MipsCpu.PC =  branch_target;
}


void    LB     () {
	_u64 off;
	
	off = Extractoffset();
	sign_extendedh(off);

	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_B ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;

	sign_extendedb( MipsCpu.GPR[CURRENT_RT].lo );
	
	INCREMENT_PC();
}



void    LBU () {
	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);


	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_B ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;

    INCREMENT_PC();
}



void    LD   () {

	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);

	
	//sign_extendedh(offset);
	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_DW ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	
	INCREMENT_PC();
}



u64 LDL_MASK[8] = { 0x00ffffffffffffff, 0x0000ffffffffffff, 0x000000ffffffffff, 0x00000000ffffffff, 
					0x0000000000ffffff, 0x000000000000ffff, 0x00000000000000ff, 0x0000000000000000 };
u32 LDL_SHIFT[8] = { 56, 48, 40, 32, 24, 16, 8, 0 };

void LDL() {
	u32 addr = (_u32)MipsCpu.GPR[CURRENT_RS].lo + (_s16)CURRENT_IMM;
	u32 shift = addr & 7;
	_u128 mem;




	MipsMemoryRead ( &mem , DATA_DW ,  addr & ~7 , 0 ) ;	
	MipsCpu.GPR[CURRENT_RT].lo =  (_u64)(( (_u64)MipsCpu.GPR[CURRENT_RT].lo & LDL_MASK[shift] ) |
									( (_u64)mem.lo << LDL_SHIFT[shift] ));


	INCREMENT_PC();
}




u64 LDR_MASK[8] = { 0x0000000000000000, 0xff00000000000000, 0xffff000000000000, 0xffffff0000000000,
					0xffffffff00000000, 0xffffffffff000000, 0xffffffffffff0000, 0xffffffffffffff00 };
u32 LDR_SHIFT[8] = { 0, 8, 16, 24, 32, 40, 48, 56 };

void LDR() {  
	u32 addr = (_u32)MipsCpu.GPR[CURRENT_RS].lo + (_s16)CURRENT_IMM;
	u32 shift = addr & 7;

	_u128 mem;



	MipsMemoryRead ( &mem , DATA_DW ,  addr & ~7 , 0 ) ;
	MipsCpu.GPR[CURRENT_RT].lo = (_u64)(( (_u64)MipsCpu.GPR[CURRENT_RT].lo & LDR_MASK[shift] ) |
									((_u64)mem.lo >> LDR_SHIFT[shift])   );


	INCREMENT_PC();
}





void    LH    () {

	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);


	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_HW ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	sign_extendedh( MipsCpu.GPR[CURRENT_RT].lo );
	
	INCREMENT_PC();
}


void    LHU () {

	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);

	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_HW ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	
	INCREMENT_PC();
}



void    LUI  () {

   	MipsCpu.GPR[CURRENT_RT].lo = (_u64)( (_s32)(CURRENT_IMM << 16) );

    INCREMENT_PC();
}



void    LW   () {

	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);



	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_W ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	sign_extended( MipsCpu.GPR[CURRENT_RT].lo );

    INCREMENT_PC();


}



u32 LWL_MASK[4] = { 0xffffff, 0xffff, 0xff, 0 };
u32 LWL_SHIFT[4] = { 24, 16, 8, 0 };

void LWL() {

	_u32 addr = (_u32)MipsCpu.GPR[CURRENT_RS].lo + (_s16)CURRENT_IMM;

	_u32 shift = addr & 3;
	_u128 mem;




	MipsMemoryRead ( &mem , DATA_W ,  (addr & ~3) , 0 ) ;

	MipsCpu.GPR[CURRENT_RT].lo = (_u64)( ((_u32)MipsCpu.GPR[CURRENT_RT].lo  &LWL_MASK[shift]) |
					 				( (_u32)mem.lo << LWL_SHIFT[shift] ));

    INCREMENT_PC();

}








u32 LWR_MASK[4] = { 0, 0xff000000, 0xffff0000, 0xffffff00 };
u32 LWR_SHIFT[4] = { 0, 8, 16, 24 };

void LWR() {
	_u32 addr = (_u32)MipsCpu.GPR[CURRENT_RS].lo + (_s16)CURRENT_IMM;

	u32 shift = addr & 3;

	_u128	mem;


	MipsMemoryRead ( &mem , DATA_W ,  (addr & ~3) , 0 ) ;

	MipsCpu.GPR[CURRENT_RT].lo = (_u64)( ((_u32)MipsCpu.GPR[CURRENT_RT].lo &   LWR_MASK[shift]) |
					   				((_u32)mem.lo >> LWR_SHIFT[shift]));

	INCREMENT_PC();

}





void    LWU   () {
	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);



	
	MipsMemoryRead ( &MipsCpu.GPR[CURRENT_RT] , DATA_W ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;

    INCREMENT_PC();
}



void   MFHI   () {
	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)MipsCpu.GPR[CPU_REG_HI].lo;

    INCREMENT_PC();
}




void   MFLO  () {		
	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)MipsCpu.GPR[CPU_REG_LO].lo;

    INCREMENT_PC();
}




void   MOVN() {
	
	if(  MipsCpu.GPR[CURRENT_RT].lo != 0 ) MipsCpu.GPR[CURRENT_RD].lo = (_u64)MipsCpu.GPR[CURRENT_RS].lo ;
		
	INCREMENT_PC();
}



void   MOVZ() {		

	
	if(  MipsCpu.GPR[CURRENT_RT].lo == 0 ) MipsCpu.GPR[CURRENT_RD].lo = (_u64)MipsCpu.GPR[CURRENT_RS].lo ;
		
	INCREMENT_PC();
}



void   MTHI  () {	


	
	MipsCpu.GPR[CPU_REG_HI].lo = (_u64)MipsCpu.GPR[CURRENT_RS].lo ;

    INCREMENT_PC();

}


void   MTLO  () {		
	
	MipsCpu.GPR[CPU_REG_LO].lo = (_u64)MipsCpu.GPR[CURRENT_RS].lo ;

    INCREMENT_PC();
}



void   MULT     () {
	_s64 temp;


	temp = (_s64)  (((_s64)((_s32)MipsCpu.GPR[CURRENT_RS].lo))  *  ((_s64)((_s32) MipsCpu.GPR[CURRENT_RT].lo))) ;


	MipsCpu.GPR[CPU_REG_LO].lo = (_u64)((_s32)(temp & 0xffffffff));
	MipsCpu.GPR[CPU_REG_HI].lo = (_u64)((_s32)((_u64)temp >> 32)) ;
		

	if ( CURRENT_RD != 0 ) MipsCpu.GPR[CURRENT_RD].lo = MipsCpu.GPR[CPU_REG_LO].lo ;

	INCREMENT_PC();
}



void   MULTU() {		
    _u64 temp;



	temp = (_u64)  (((_u64)((_u32)MipsCpu.GPR[CURRENT_RS].lo))  *  ((_u64)((_u32) MipsCpu.GPR[CURRENT_RT].lo))) ;


	MipsCpu.GPR[CPU_REG_LO].lo = (_u64)((_s32)(temp & 0xffffffff));
	MipsCpu.GPR[CPU_REG_HI].lo = (_u64)((_s32)((_u64)temp >> 32)) ;

		
	if ( CURRENT_RD != 0 ) MipsCpu.GPR[CURRENT_RD].lo = MipsCpu.GPR[CPU_REG_LO].lo ;
	
	INCREMENT_PC();
}




void   NOR   () {	


    MipsCpu.GPR[CURRENT_RD].lo = (_u64)(~((_u64)MipsCpu.GPR[CURRENT_RS].lo | (_u64)MipsCpu.GPR[CURRENT_RT].lo));

    INCREMENT_PC();
 
}




void   OR () {

    MipsCpu.GPR[CURRENT_RD].lo =(_u64)((_u64)MipsCpu.GPR[CURRENT_RS].lo | (_u64)MipsCpu.GPR[CURRENT_RT].lo);
 
    INCREMENT_PC();
}



void    ORI () {

	MipsCpu.GPR[CURRENT_RT].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RS].lo | (_u64)CURRENT_IMM);
	
	INCREMENT_PC();
}



void    PREF () {	PrintDebugOpcode() ; MipsCpu.halt = 1;

}


void    SB     () {
	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);


	MipsMemoryWrite ( MipsCpu.GPR[CURRENT_RT] , DATA_B ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	
	INCREMENT_PC();
}



void    SD() {

	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);


	MipsMemoryWrite ( MipsCpu.GPR[CURRENT_RT] , DATA_DW ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	
	INCREMENT_PC();
}



u64 SDL_MASK[8] = { 0xffffffffffffff00, 0xffffffffffff0000, 0xffffffffff000000, 0xffffffff00000000, 
					0xffffff0000000000, 0xffff000000000000, 0xff00000000000000, 0x0000000000000000 };
u32 SDL_SHIFT[8] = { 56, 48, 40, 32, 24, 16, 8, 0 };

void SDL() {
	u32 addr = (_u32)MipsCpu.GPR[CURRENT_RS].lo +(_s16) CURRENT_IMM;
	u32 shift = addr & 7;
	_u128 memr;
	_u128 memw;




	MipsMemoryRead ( &memr , DATA_DW ,  addr & ~7 , 0 ) ;


	memw.lo = ( (_u64)MipsCpu.GPR[CURRENT_RT].lo >> SDL_SHIFT[shift]  ) |  ( (_u64)memr.lo & SDL_MASK[shift]);

	MipsMemoryWrite ( memw , DATA_DW ,  addr & ~7 , 0 ) ;

	INCREMENT_PC();
}



u64 SDR_MASK[8] = { 0x0000000000000000, 0x00000000000000ff, 0x000000000000ffff, 0x0000000000ffffff,
					0x00000000ffffffff, 0x000000ffffffffff, 0x0000ffffffffffff, 0x00ffffffffffffff };
u32 SDR_SHIFT[8] = { 0, 8, 16, 24, 32, 40, 48, 56 };

void SDR() {
	u32 addr = (_u32)MipsCpu.GPR[CURRENT_RS].lo +  (_s16)CURRENT_IMM;
	u32 shift = addr & 7;
	
	_u128 memr;
	_u128 memw;




	MipsMemoryRead ( &memr , DATA_DW ,  addr & ~7 , 0 ) ;


	memw.lo = (_u64)(( (_u64)MipsCpu.GPR[CURRENT_RT].lo << SDR_SHIFT[shift]) |   ( (_u64)memr.lo & SDR_MASK[shift] ) );

	MipsMemoryWrite ( memw , DATA_DW ,  addr & ~7 , 0 ) ;

	INCREMENT_PC();
}


void    SH    () {
	
	_u64 off;
	off = Extractoffset();
	sign_extendedh(off);


	MipsMemoryWrite ( MipsCpu.GPR[CURRENT_RT] , DATA_HW ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	
	INCREMENT_PC();
}


void   SLL() {



	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u32)MipsCpu.GPR[CURRENT_RT].lo ) <<  CURRENT_SA;
	
	INCREMENT_PC();
}


void   SLLV () {		


	MipsCpu.GPR[CURRENT_RD].lo = (_u64)( (_s32)MipsCpu.GPR[CURRENT_RT].lo  ) <<  ( (_u32)MipsCpu.GPR[CURRENT_RS].lo & 0x1F);	

	INCREMENT_PC();
}


void   SLT () {



	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s64) MipsCpu.GPR[CURRENT_RS].lo < (_s64) MipsCpu.GPR[CURRENT_RT].lo );
	
	INCREMENT_PC();
}



void    SLTI() {

	MipsCpu.GPR[CURRENT_RT].lo = (_u64)( (_s64)MipsCpu.GPR[CURRENT_RS].lo < (_s64)((_s16)CURRENT_IMM));
	
	INCREMENT_PC();
}




void    SLTIU() {

	MipsCpu.GPR[CURRENT_RT].lo = (_u64)( (_u64)MipsCpu.GPR[CURRENT_RS].lo < ((_u64)(_u16)CURRENT_IMM) );
	
	INCREMENT_PC();
}



void   SLTU   () {

	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64) MipsCpu.GPR[CURRENT_RS].lo < (_u64)MipsCpu.GPR[CURRENT_RT].lo );

	
	INCREMENT_PC();
}




void   SRA  () {
	_u64 temp;
	_u8 boucle;


	MipsCpu.GPR[CURRENT_RD].lo =  (_s64)((_s32)MipsCpu.GPR[CURRENT_RT].lo >>  CURRENT_SA);

     		
	INCREMENT_PC();
}




void   SRAV () {		
	_u64 temp;
	_u8 boucle;


	MipsCpu.GPR[CURRENT_RD].lo =  (_s64)((_s32)MipsCpu.GPR[CURRENT_RT].lo >>  ( (_u32)MipsCpu.GPR[CURRENT_RS].lo & 0x1F)) ; 

	INCREMENT_PC();
}



void   SRL   () {
		
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)(((_u32)MipsCpu.GPR[CURRENT_RT].lo)  >>  CURRENT_SA);	

	INCREMENT_PC();
}



void   SRLV () {	


	MipsCpu.GPR[CURRENT_RD].lo = (_u64)(((_u32)MipsCpu.GPR[CURRENT_RT].lo)  >>  ( (_u32)MipsCpu.GPR[CURRENT_RS].lo & 0x1F));	
	
	INCREMENT_PC();
}





void   SUB () {
	_u64 temp;


	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s32)MipsCpu.GPR[CURRENT_RS].lo - (_s32)MipsCpu.GPR[CURRENT_RT].lo);
	
	INCREMENT_PC();
}



void   SUBU   () {

	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_s32)MipsCpu.GPR[CURRENT_RS].lo - (_s32)MipsCpu.GPR[CURRENT_RT].lo);

	
	INCREMENT_PC();
}



void    SW   () {

	MipsMemoryWrite ( MipsCpu.GPR[CURRENT_RT] , DATA_W ,  MipsCpu.GPR[CURRENT_BASE].lo , (_s16)CURRENT_OFFSET ) ;

    INCREMENT_PC();
}


u32 SWL_MASK[4] = { 0xffffff00, 0xffff0000, 0xff000000, 0x00000000 };
u32 SWL_SHIFT[4] = { 24, 16, 8, 0 };

void SWL() {
	_u32 addr = MipsCpu.GPR[CURRENT_RS].lo + CURRENT_IMM;
	u32 shift = addr & 3;
	_u128 memr;
	_u128 memw;


	MipsMemoryRead ( &memr , DATA_W ,  addr & ~3 , 0 ) ;


	memw.lo = ((_u32)MipsCpu.GPR[CURRENT_RT].lo >> SWL_SHIFT[shift]) |
		      (  (_u32)memr.lo & SWL_MASK[shift]) ;


	MipsMemoryWrite ( memw , DATA_W ,  addr & ~3 , 0 ) ;

    INCREMENT_PC();

}




u32 SWR_MASK[4] = { 0x00000000, 0x000000ff, 0x0000ffff, 0x00ffffff };
u32 SWR_SHIFT[4] = { 0, 8, 16, 24 };

void SWR() {
	u32 addr = MipsCpu.GPR[CURRENT_RS].lo + CURRENT_IMM;
	u32 shift = addr & 3;
	_u128 memr, memw;



	MipsMemoryRead ( &memr , DATA_W ,  addr & ~3 , 0 ) ;

	memw.lo = ((_u32)MipsCpu.GPR[CURRENT_RT].lo << SWR_SHIFT[shift]) |
	      ( (_u32)memr.lo & SWR_MASK[shift]) ;


	MipsMemoryWrite ( memw , DATA_W ,  addr & ~3 , 0 ) ;


	INCREMENT_PC();

}



void   SYNC  () {

    INCREMENT_PC();
}



void   SYSCALL() {
	_u8		SystemCallNumber;	

	char temp_string[256];
	
 	
  	SystemCallNumber = MipsCpu.GPR[CPU_REG_V1].lo & 0xFF;
	
 	if ((signed char)SystemCallNumber < 0) SystemCallNumber = (- SystemCallNumber ) & 0xFF ;

 	syscall_fct_ns[SystemCallNumber]();
}



void   TEQ() 	{	PrintDebugOpcode() ; INCREMENT_PC();		}

void   TEQI() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TGE() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TGEI() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TGEIU() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TGEU() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TLT() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TLTI() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TLTIU() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TLTU() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TNE() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}

void   TNEI() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;		}


void   XOR  () {
	
	MipsCpu.GPR[CURRENT_RD].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RS].lo ^ (_u64)MipsCpu.GPR[CURRENT_RT].lo);
	
	INCREMENT_PC();
}



void    XORI () {
	
	MipsCpu.GPR[CURRENT_RT].lo = (_u64)((_u64)MipsCpu.GPR[CURRENT_RS].lo ^ (_u64)CURRENT_IMM);
	
	INCREMENT_PC();
}



/*****************************************************************************************************************
									UNCLASSIFIED INSTRUCTION SET
*****************************************************************************************************************/





void	CVT_D()		{	PrintDebugOpcode() ; MipsCpu.halt = 1;}			



void	MOVF_fmt()	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void	MOVT_fmt()	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}	



