/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef _R5900_CORE_TABLE_H
#define _R5900_CORE_TABLE_H



static void (*normal_opc[64])(void) =
{
   SPECIAL,	REGIMM,		J,		JAL,	BEQ,		BNE,	BLEZ,	BGTZ,
   ADDI, 	ADDIU, 		SLTI,	SLTIU,	ANDI,		ORI,	XORI,	LUI,
   COP0, 	COP1, 		COP2,	NI,		BEQL,		BNEL,	BLEZL,	BGTZL,
   DADDI, 	DADDIU, 	LDL,	LDR,	SPECIAL2,	NI,		LQ,		SQ,
   LB, 		LH, 		LWL,	LW,		LBU,		LHU,	LWR,	LWU,
   SB, 		SH, 		SWL,	SW,		SDL,		SDR,	SWR,	CACHE,
   NI, 		LWC1, 		NI,		PREF,	NI,			NI,		LQC2,	LD,
   NI, 		SWC1, 		NI,		NI,		NI, 		NI,		SQC2,	SD
};



static char * debug_normal_opc[64] =
{
   "SPECIAL",	"REGIMM",	"J",	"JAL",		"BEQ",		"BNE",	"BLEZ",		"BGTZ",
   "ADDI",		"ADDIU",	"SLTI",	"SLTIU",	"ANDI",		"ORI",	"XORI", 	"LUI",
   "COP0",		"COP1",		"COP2",	"NI",		"BEQL",		"BNEL",	"BLEZL", 	"BGTZL",
   "DADDI",		"DADDIU",	"LDL",	"LDR",		"SPECIAL2",	"NI",	"LQ", 		"SQ",
   "LB",		"LH",		"LWL",	"LW",		"LBU",		"LHU",	"LWR",		"LWU",
   "SB",		"SH",		"SWL",	"SW",		"SDL",		"SDR",	"SWR",		"CACHE",
   "NI",		"LWC1",		"NI",	"PREF",		"NI",		"NI",	"LQC2",		"LD",
   "NI",		"SWC1",		"NI",	"NI",		"NI",		"NI",	"SQC2",		"SD"
};



static void (*special_opc[64])(void) =
{
   SLL,		NI,		SRL,	SRA,	SLLV,		NI,		SRLV,	SRAV,
   JR,		JALR,	MOVZ,	MOVN,	SYSCALL,	BREAK,	NI,		SYNC,
   MFHI,	MTHI,	MFLO,	MTLO,	DSLLV,		NI,		DSRLV,	DSRAV,
   MULT,	MULTU,	DIV,	DIVU,	NI,			NI,		NI,		NI,
   ADD,		ADDU,	SUB,	SUBU,	AND,		OR,		XOR,	NOR,
   MFSA,	MTSA,	SLT,	SLTU,	DADD,		DADDU,	DSUB,	DSUBU,
   TGE,		TGEU,	TLT,	TLTU,	TEQ,		NI,		TNE,	NI,
   DSLL,	NI,		DSRL,	DSRA,	DSLL32,		NI,		DSRL32,	DSRA32
};


static char * debug_special_opc[64] =
{
   "SLL",	"NI",		"SRL",	"SRA",	"SLLV",		"NI",		"SRLV",		"SRAV",
   "JR",	"JALR ",	"MOVZ",	"MOVN",	"SYSCALL",	"BREAK",	"NI",		"SYNC",
   "MFHI",	"MTHI",		"MFLO",	"MTLO",	"DSLLV",	"NI",		"DSRLV",	"DSRAV",
   "MULT",	"MULTU", 	"DIV",	"DIVU",	"NI",		"NI",		"NI",		"NI",
   "ADD",	"ADDU", 	"SUB",	"SUBU",	"AND",		"OR",		"XOR",		"NOR",
   "MFSA",	"MTSA",		"SLT",	"SLTU",	"DADD",		"DADDU",	"DSUB",		"DSUBU",
   "TGE",	"TGEU", 	"TLT",	"TLTU",	"TEQ",		"NI",		"TNE",		"NI",
   "DSLL",	"NI", 		"DSRL",	"DSRA",	"DSLL32",	"NI",		"DSRL32",	"DSRA32"
};



static void (*regimm_opc[32])(void) =
{
   BLTZ,	BGEZ,	BLTZL,		BGEZL,		NI,		NI,	NI,		NI,
   TGEI,	TGEIU, 	TLTI,		TLTIU,		TEQI,	NI,	TNEI,	NI,
   BLTZAL,	BGEZAL, BLTZALL,	BGEZALL,	NI,		NI,	NI,		NI,
   MTSAB,	MTSAH,	NI,			NI,			NI,		NI, NI,		NI 
};



static char * debug_regimm_opc[32] =
{
   "BLTZ",		"BGEZ",		"BLTZL",	"BGEZL",	"NI",	"NI",	"NI",	"NI",
   "TGEI",		"TGEIU", 	"TLTI",		"TLTIU",	"TEQI", "NI",	"TNEI",	"NI",
   "BLTZAL",	"BGEZAL",	"BLTZALL",	"BGEZALL",	"NI",	"NI",	"NI",	"NI",
   "MTSAB",		"MTSAH",	"NI",		"NI",		"NI",	"NI",	"NI",	"NI" 
};


























#endif
